package s05.demineur;
 
public abstract class CaseAbstraite implements ICase {
	private ITerrainMine terrain;
	private int colonne, ligne;
	private boolean cachee;
	private boolean marquee;
 
	public CaseAbstraite(ITerrainMine terrain, int colonne, int ligne) {
		if (terrain==null || colonne<0 || ligne<0 || colonne>=terrain.getNbColonnes() || ligne>=terrain.getNbLignes()) {
			throw new IllegalArgumentException();
		}
		this.terrain = terrain;
		this.colonne=colonne;
		this.ligne=ligne;
		this.cachee = true;
		this.marquee = false;
	}
	public int getColonne() {
		return this.colonne;
	}
	public int getLigne() {
		return this.ligne;
	}
	public ITerrainMine getTerrain() {
		return this.terrain;
	}
	public boolean estMarquee() {
		return this.marquee;
	}
	public void setMarquee(boolean m) {
		this.marquee=m;
	}
	public boolean estCachee() {
		return this.cachee;
	}
	public void devoiler() {
		this.cachee=false;
	}
}
