package s05.demineur;
 
public interface ICase {
	public static final int VIDE = 0;
	public static final int MINEE = 10;
 
	/**
	 * @return Retourne l'index de la colonne dans laquelle est situee la case
	 * dans son terrain mine
	 */
	public int getColonne();
	/**
	 * @return Retourne l'index de la ligne dans laquelle est situee la case
	 * dans son terrain mine
	 */
	public int getLigne() ;
	/**
	 * @return Retourne le terrain mine dans lequel elle est situee
	 */
	public ITerrainMine getTerrain();
	/**
	 * @return Retourne MINEE si la case est minee,
	 * VIDE si la case est vide (sans case minee adjacente)
	 * et le nombre de cases adjacentes minees sinon
	 */
	public int getValeur();
	/**
	 * @return Retourne true si la case contient une mine. Sinon retourne false.
	 */
	public boolean estMinee();
	/**
	 * @return Retourne true si la case est marquee d'un drapeau (sinon retourne false).
	 */
	public boolean estMarquee();
	/**
	 * Rend la case marquee (si m vaut true) ou non marquee (si m vaut false)
	 * @param m un booleen
	 */
	public void setMarquee(boolean m);
	/**
	 * @return Retourne true si la case est cachee (son contenu n'est pas encore devoile),
	 *  et retourne false sinon.
	 */
	public boolean estCachee();
	/**
	 * Devoile le contenu de la case (elle n'est plus cachee)
	 */
	public void devoiler();
 
	/**
	 * Methode appelee lorsqu'un clic sur la case a lieu
	 */
	public void clic();
	/**
	 * Methode appelee lorsqu'une case voisine vient d'etre devoilee (elle n'est plus masquee)
	 */
	public void propager();
 
}
