package s05.demineur;
public class TerrainMine implements ITerrainMine{
	private ICase[][] terrain;
 
	public TerrainMine(int nbCol, int nbLig, int nbMines) {
		this.terrain = new ICase[nbCol][nbLig];
		//*// CaseMinee Decommentez :  /* ==>  //*
		for (int i=0; i<nbMines; i++) {
			int c, l;
			do {
				c= ((int)(Math.random()*nbCol));
				l= ((int)(Math.random()*nbLig));
			} while (this.terrain[c][l]!=null);
			this.terrain[c][l]=new CaseMinee(this, c,l);
		}//*/
		for (int col=0; col<nbCol; col++) {
			for (int lig=0; lig<nbLig; lig++) {
				if (this.terrain[col][lig]==null) {
					int cpt=0;
					if (this.estMinee(col-1,  lig-1)) {
						cpt++;
					}
					if (this.estMinee(col,  lig-1)) {
						cpt++;
					}
					if (this.estMinee(col+1,  lig-1)) {
						cpt++;
					}
					if (this.estMinee(col-1,  lig)) {
						cpt++;
					}
					if (this.estMinee(col+1,  lig)) {
						cpt++;
					}
					if (this.estMinee(col-1,  lig+1)) {
						cpt++;
					}
					if (this.estMinee(col,  lig+1)) {
						cpt++;
					}
					if (this.estMinee(col+1,  lig+1)) {
						cpt++;
					}
					//*// CaseVide Decommentez :   /*  ==>  //*
						this.terrain[col][lig]= new CaseVide(this, col, lig);
					//*/
					if (cpt!=0) {
						//*// CaseNumerotee Decommentez :  /* ==> //*
						this.terrain[col][lig]=new CaseNumerotee(this, col, lig,cpt);
						//*/
					}
				}
			}
		}
	}
	
	private boolean estMinee(int col, int lig) {
		if (col<0 || col>=this.getNbColonnes() || lig<0 || lig>=this.getNbLignes()) {
			return false;
		} else if (this.terrain[col][lig]==null) {
				return false;
		} else {
				return this.terrain[col][lig].estMinee();
		}
	}
	public int getNbColonnes() {
		return this.terrain.length;
	}
	public int getNbLignes() {
		return this.terrain[0].length;
	}
	public ICase get(int col, int lig) {
		if (col<0 || col>=this.getNbColonnes() || lig<0 || lig>=this.getNbLignes()) {
			return null;
		} else {
			return this.terrain[col][lig];
		}
	}
	public boolean perdu() {
		int l=0,c=0;
		boolean perdu = false;
		while (!perdu && l<this.getNbLignes()) {
			c=0;
			while (!perdu && c<this.getNbColonnes()) {
				perdu = this.estMinee(c, l) && !this.get(c,l).estCachee();
				c++;
			}
			l++;
		}
		return perdu;
	}
	public boolean gagne() {
		boolean toutDevoile = true;
		int l=0, c=0;
		while (toutDevoile && l<this.getNbLignes()) {
			c=0;
			while (toutDevoile && c<this.getNbColonnes()) {
				toutDevoile = this.estMinee(c, l) || !this.get(c,l).estCachee();
				c++;
			}
			l++;
		}
		return toutDevoile;
	}
}
