package s05.tests.tools;

import java.io.File;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import s05.demineur.ICase;
import s05.demineur.ITerrainMine;
import s05.demineur.TerrainMine;

public class TestS05 {




	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test01CaseVideConstructeur() {
		Class cICase = Reflexion.getClass("s05.demineur.ICase");
		if (cICase==null) {
			System.out.println("   Aie... je ne trouve pas l'interface ICase dans le package demineur");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cCaseAbstraite= Reflexion.getClass("s05.demineur.CaseAbstraite");
		if (cCaseAbstraite==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseAbstraite dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseVide= Reflexion.getClass("s05.demineur.CaseVide");
		if (cCaseVide==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseVide dans le package demineur. Impossible de tester");
			return 0;
		}
		Field fieldTerrain=null, fieldColonne=null, fieldLigne=null, fieldMarquee=null, fieldCachee=null, fieldOther=null;
		Field[] tf = cCaseAbstraite.getDeclaredFields();
		//int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {
		//		nbv++;
			}
			if ( f.getType().equals(ITerrainMine.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldTerrain==null) {
					fieldTerrain=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("col")) {
				if (fieldColonne==null) {
					fieldColonne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("lig")) {
				if (fieldLigne==null) {
					fieldLigne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("mar")) {
				if (fieldMarquee==null) {
					fieldMarquee=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("mar")) {
				if (fieldCachee==null) {
					fieldCachee=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldTerrain==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance referencant le terrain.");
			return 0;
		}
		if (fieldColonne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la colonne.");
			return 0;
		}
		if (fieldLigne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la ligne.");
			return 0;
		}
		if (fieldMarquee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est marquee.");
			return 0;
		}
		if (fieldCachee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est cachee.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Vous n'avez pas a ajouter de variables dans la classe CaseAbstraite");
			return 0;
		}
		if (!Reflexion.implementsInterface(cCaseAbstraite, cICase)) {
			System.out.println("   Aie... La classe CaseAbstraite n'implemente pas l'interface ICase.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldTerrain.getModifiers())
				|| !Modifier.isPrivate(fieldColonne.getModifiers())
				|| !Modifier.isPrivate(fieldLigne.getModifiers())
				|| !Modifier.isPrivate(fieldMarquee.getModifiers())
				|| !Modifier.isPrivate(fieldCachee.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation les variables d'instance doivent etre declarees private");
			return 0;
		}
		if (!Reflexion.extendsClass(cCaseVide, cCaseAbstraite)) {
			System.out.println("   Aie... CaseVide n'etends pas CaseAbstraite. CaseVide doit heriter de CaseAbstraite.");
			return 0;
		}
		Class[] arg2 = { ITerrainMine.class, int.class, int.class };
		Constructor const1=null;
		try {
			const1 = cCaseVide.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
		//	e.printStackTrace();
			const1=null;
		} catch (SecurityException e) {
		//	e.printStackTrace();
			const1=null;
		}
		if (const1==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur CaseVide(ITerrainMine terrain, int colonne, int ligne). Impossible de tester");
			return 0;
		}
		if (Modifier.isPrivate(const1.getModifiers())|| Modifier.isProtected(const1.getModifiers())) {
			System.out.println("   Aie... le constructeur de CaseVide devrait etre public");
		}
		const1.setAccessible(true);
		fieldTerrain.setAccessible(true);
		fieldLigne.setAccessible(true);
		fieldColonne.setAccessible(true);
		fieldCachee.setAccessible(true);
		fieldMarquee.setAccessible(true);
		Object[][] args = { 
				{new TerrainMine(10,8,4), Integer.valueOf(9), Integer.valueOf(7)},
				{new TerrainMine(10,8,4), Integer.valueOf(2), Integer.valueOf(4)},
				{new TerrainMine(10,8,4), Integer.valueOf(5), Integer.valueOf(3)},
				};

		for (int i=0; i<args.length; i++) {
			Object pt1=null;
			ITerrainMine resTerrain=null;
			int resColonne=0;
			int resLigne=0;
			boolean resMarquee=true;
			boolean resCachee=false;
			try {
				pt1 = (const1.newInstance(args[i]));
				resTerrain = (ITerrainMine)(fieldTerrain.get(pt1));
				if (resTerrain!=(ITerrainMine)args[i][0]) {
					System.out.println("   Aie... le constructeur de CaseVide n'initialise pas convenablement le terrain\n");
					return 0;
				}
				resColonne = (int)(fieldColonne.get(pt1));
				if (resColonne!=(int)args[i][1]) {
					System.out.println("   Aie... le constructeur de CaseVide n'initialise pas convenablement la colonne\n");
					return 0;
				}
				resLigne = (int)(fieldLigne.get(pt1));
				if (resLigne!=(int)args[i][2]) {
					System.out.println("   Aie... le constructeur de CaseVide n'initialise pas convenablement la lignee\n");
					return 0;
				}
				resMarquee = (boolean)(fieldMarquee.get(pt1));
				if (resMarquee) {
					System.out.println("   Aie... le constructeur de CaseVide n'initialise pas convenablement marquee\n");
					return 0;
				}
				resCachee = (boolean)(fieldCachee.get(pt1));
				if (!resCachee) {
					System.out.println("   Aie... le constructeur de CaseVide n'initialise pas convenablement cachee\n");
					return 0;
				}
			} catch (Exception e) {
				if (e instanceof InvocationTargetException) {
					e.getCause().printStackTrace();
				} else {
					e.printStackTrace();
				}
				return 0;
			}
		}
		String[] argss={"ITerrainMine", "int", "int"};
		String co = Reflexion.constructeurNomFic("src"+File.separator+"s05"+File.separator+"demineur"+File.separator+"CaseVide.java", "CaseVide", argss);
		co=Reflexion.sansEspacesAvantParentheses(co);
		//System.out.println(">>>"+co+"<<<");
		if ( !co.contains("super(")) {
			System.out.println("   Aie... Le constructeur de CaseVide ne fait pas appel au constructeur de sa super-classe");
			return 0;
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}



	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test02CaseVideGetValeur() {
		Class cICase = Reflexion.getClass("s05.demineur.ICase");
		if (cICase==null) {
			System.out.println("   Aie... je ne trouve pas l'interface ICase dans le package demineur");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cCaseAbstraite= Reflexion.getClass("s05.demineur.CaseAbstraite");
		if (cCaseAbstraite==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseAbstraite dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseVide= Reflexion.getClass("s05.demineur.CaseVide");
		if (cCaseVide==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseVide dans le package demineur. Impossible de tester");
			return 0;
		}
		Field fieldTerrain=null, fieldColonne=null, fieldLigne=null, fieldMarquee=null, fieldCachee=null, fieldOther=null;
		Field[] tf = cCaseAbstraite.getDeclaredFields();
		//int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {
		//		nbv++;
			}
			if ( f.getType().equals(ITerrainMine.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldTerrain==null) {
					fieldTerrain=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("col")) {
				if (fieldColonne==null) {
					fieldColonne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("lig")) {
				if (fieldLigne==null) {
					fieldLigne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("mar")) {
				if (fieldMarquee==null) {
					fieldMarquee=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("mar")) {
				if (fieldCachee==null) {
					fieldCachee=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldTerrain==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance referencant le terrain.");
			return 0;
		}
		if (fieldColonne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la colonne.");
			return 0;
		}
		if (fieldLigne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la ligne.");
			return 0;
		}
		if (fieldMarquee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est marquee.");
			return 0;
		}
		if (fieldCachee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est cachee.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Vous n'avez pas a ajouter de variables dans la classe CaseAbstraite");
			return 0;
		}
		if (!Reflexion.implementsInterface(cCaseAbstraite, cICase)) {
			System.out.println("   Aie... La classe CaseAbstraite n'implemente pas l'interface ICase.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldTerrain.getModifiers())
				|| !Modifier.isPrivate(fieldColonne.getModifiers())
				|| !Modifier.isPrivate(fieldLigne.getModifiers())
				|| !Modifier.isPrivate(fieldMarquee.getModifiers())
				|| !Modifier.isPrivate(fieldCachee.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation les variables d'instance doivent etre declarees private");
			return 0;
		}
		if (!Reflexion.extendsClass(cCaseVide, cCaseAbstraite)) {
			System.out.println("   Aie... CaseVide n'etends pas CaseAbstraite. CaseVide doit heriter de CaseAbstraite.");
			return 0;
		}
		Class[] arg2 = { ITerrainMine.class, int.class, int.class };
		Constructor const1=null;
		try {
			const1 = cCaseVide.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
		//	e.printStackTrace();
			const1=null;
		} catch (SecurityException e) {
		//	e.printStackTrace();
			const1=null;
		}
		if (const1==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur CaseVide(ITerrainMine terrain, int colonne, int ligne). Impossible de tester");
			return 0;
		}
		if (Modifier.isPrivate(const1.getModifiers())|| Modifier.isProtected(const1.getModifiers())) {
			System.out.println("   Aie... le constructeur de CaseVide devrait etre public");
		}
		const1.setAccessible(true);
		fieldTerrain.setAccessible(true);
		fieldLigne.setAccessible(true);
		fieldColonne.setAccessible(true);
		fieldCachee.setAccessible(true);
		fieldMarquee.setAccessible(true);
		Object[][] args = { 
				{new TerrainMine(10,8,4), Integer.valueOf(9), Integer.valueOf(7)},
				{new TerrainMine(10,8,4), Integer.valueOf(2), Integer.valueOf(4)},
				{new TerrainMine(10,8,4), Integer.valueOf(5), Integer.valueOf(3)},
				};
		Class[] ar = {};
		Method mGetValeur=null;
		try {
			mGetValeur = cCaseVide.getDeclaredMethod("getValeur", ar);
		} catch (NoSuchMethodException e1) {
		//	e1.printStackTrace();
			mGetValeur=null;
		} catch (SecurityException e1) {
		//	e1.printStackTrace();
			mGetValeur=null;
		}
		if (mGetValeur==null) {
			System.out.println("   Aie... je ne trouve pas la methode getValeur() dans la classe CaseVide()");
			return 0;
		}
		Object[] paramb= {};

		for (int i=0; i<args.length; i++) {
			Object pt1=null;
			int res=-1;
			try {
				pt1 = (const1.newInstance(args[i]));
				fieldTerrain.set(pt1, args[i][0]);
				fieldColonne.set(pt1, args[i][1]);
				fieldLigne.set(pt1, args[i][2]);
				fieldCachee.set(pt1, Boolean.valueOf(true));
				fieldMarquee.set(pt1, Boolean.valueOf(false));
				res = (int)(mGetValeur.invoke(pt1, paramb));
				if (res!=ICase.VIDE) {
					System.out.println("   Aie... getValeur() de CaseVide doit toujours retourner ICase.VIDE ce qui n'est pas le cas de votre implementation");
					return 0;
				}

			} catch (Exception e) {
				if (e instanceof InvocationTargetException) {
					e.getCause().printStackTrace();
				} else {
					e.printStackTrace();
				}
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}

	



	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test03CaseVideEstMinee() {
		Class cICase = Reflexion.getClass("s05.demineur.ICase");
		if (cICase==null) {
			System.out.println("   Aie... je ne trouve pas l'interface ICase dans le package demineur");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cCaseAbstraite= Reflexion.getClass("s05.demineur.CaseAbstraite");
		if (cCaseAbstraite==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseAbstraite dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseVide= Reflexion.getClass("s05.demineur.CaseVide");
		if (cCaseVide==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseVide dans le package demineur. Impossible de tester");
			return 0;
		}
		Field fieldTerrain=null, fieldColonne=null, fieldLigne=null, fieldMarquee=null, fieldCachee=null, fieldOther=null;
		Field[] tf = cCaseAbstraite.getDeclaredFields();
		//int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {
			//	nbv++;
			}
			if ( f.getType().equals(ITerrainMine.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldTerrain==null) {
					fieldTerrain=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("col")) {
				if (fieldColonne==null) {
					fieldColonne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("lig")) {
				if (fieldLigne==null) {
					fieldLigne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("mar")) {
				if (fieldMarquee==null) {
					fieldMarquee=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("mar")) {
				if (fieldCachee==null) {
					fieldCachee=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldTerrain==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance referencant le terrain.");
			return 0;
		}
		if (fieldColonne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la colonne.");
			return 0;
		}
		if (fieldLigne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la ligne.");
			return 0;
		}
		if (fieldMarquee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est marquee.");
			return 0;
		}
		if (fieldCachee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est cachee.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Vous n'avez pas a ajouter de variables dans la classe CaseAbstraite");
			return 0;
		}
		if (!Reflexion.implementsInterface(cCaseAbstraite, cICase)) {
			System.out.println("   Aie... La classe CaseAbstraite n'implemente pas l'interface ICase.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldTerrain.getModifiers())
				|| !Modifier.isPrivate(fieldColonne.getModifiers())
				|| !Modifier.isPrivate(fieldLigne.getModifiers())
				|| !Modifier.isPrivate(fieldMarquee.getModifiers())
				|| !Modifier.isPrivate(fieldCachee.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation les variables d'instance doivent etre declarees private");
			return 0;
		}
		if (!Reflexion.extendsClass(cCaseVide, cCaseAbstraite)) {
			System.out.println("   Aie... CaseVide n'etends pas CaseAbstraite. CaseVide doit heriter de CaseAbstraite.");
			return 0;
		}
		Class[] arg2 = { ITerrainMine.class, int.class, int.class };
		Constructor const1=null;
		try {
			const1 = cCaseVide.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
		//	e.printStackTrace();
			const1=null;
		} catch (SecurityException e) {
		//	e.printStackTrace();
			const1=null;
		}
		if (const1==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur CaseVide(ITerrainMine terrain, int colonne, int ligne). Impossible de tester");
			return 0;
		}
		if (Modifier.isPrivate(const1.getModifiers())|| Modifier.isProtected(const1.getModifiers())) {
			System.out.println("   Aie... le constructeur de CaseVide devrait etre public");
		}
		const1.setAccessible(true);
		fieldTerrain.setAccessible(true);
		fieldLigne.setAccessible(true);
		fieldColonne.setAccessible(true);
		fieldCachee.setAccessible(true);
		fieldMarquee.setAccessible(true);
		Object[][] args = { 
				{new TerrainMine(10,8,4), Integer.valueOf(9), Integer.valueOf(7)},
				{new TerrainMine(10,8,4), Integer.valueOf(2), Integer.valueOf(4)},
				{new TerrainMine(10,8,4), Integer.valueOf(5), Integer.valueOf(3)},
				};
		Class[] ar = {};
		Method mEstMinee=null;
		try {
			mEstMinee = cCaseVide.getDeclaredMethod("estMinee", ar);
		} catch (NoSuchMethodException e1) {
		//	e1.printStackTrace();
			mEstMinee=null;
		} catch (SecurityException e1) {
		//	e1.printStackTrace();
			mEstMinee=null;
		}
		if (mEstMinee==null) {
			System.out.println("   Aie... je ne trouve pas la methode estMinee() dans la classe CaseVide()");
			return 0;
		}
		Object[] paramb= {};

		for (int i=0; i<args.length; i++) {
			Object pt1=null;
			boolean res=true;
			try {
				pt1 = (const1.newInstance(args[i]));
				fieldTerrain.set(pt1, args[i][0]);
				fieldColonne.set(pt1, args[i][1]);
				fieldLigne.set(pt1, args[i][2]);
				fieldCachee.set(pt1, Boolean.valueOf(true));
				fieldMarquee.set(pt1, Boolean.valueOf(false));
				res = (boolean)(mEstMinee.invoke(pt1, paramb));
				if (res) {
					System.out.println("   Aie... estMinee() de CaseVide doit toujours retourner false ce qui n'est pas le cas de votre implementation");
					return 0;
				}
			} catch (Exception e) {
				if (e instanceof InvocationTargetException) {
					e.getCause().printStackTrace();
				} else {
					e.printStackTrace();
				}
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}
	
	
	
	
	
	
	



	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test04CaseMineeConstructeur() {
		Class cICase = Reflexion.getClass("s05.demineur.ICase");
		if (cICase==null) {
			System.out.println("   Aie... je ne trouve pas l'interface ICase dans le package demineur");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cCaseAbstraite= Reflexion.getClass("s05.demineur.CaseAbstraite");
		if (cCaseAbstraite==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseAbstraite dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseMinee= Reflexion.getClass("s05.demineur.CaseMinee");
		if (cCaseMinee==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseMinee dans le package demineur. Impossible de tester");
			return 0;
		}
		Field fieldTerrain=null, fieldColonne=null, fieldLigne=null, fieldMarquee=null, fieldCachee=null, fieldOther=null;
		Field[] tf = cCaseAbstraite.getDeclaredFields();
		//int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {
			//	nbv++;
			}
			if ( f.getType().equals(ITerrainMine.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldTerrain==null) {
					fieldTerrain=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("col")) {
				if (fieldColonne==null) {
					fieldColonne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("lig")) {
				if (fieldLigne==null) {
					fieldLigne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("mar")) {
				if (fieldMarquee==null) {
					fieldMarquee=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("mar")) {
				if (fieldCachee==null) {
					fieldCachee=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldTerrain==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance referencant le terrain.");
			return 0;
		}
		if (fieldColonne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la colonne.");
			return 0;
		}
		if (fieldLigne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la ligne.");
			return 0;
		}
		if (fieldMarquee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est marquee.");
			return 0;
		}
		if (fieldCachee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est cachee.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Vous n'avez pas a ajouter de variables dans la classe CaseAbstraite");
			return 0;
		}
		if (!Reflexion.implementsInterface(cCaseAbstraite, cICase)) {
			System.out.println("   Aie... La classe CaseAbstraite n'implemente pas l'interface ICase.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldTerrain.getModifiers())
				|| !Modifier.isPrivate(fieldColonne.getModifiers())
				|| !Modifier.isPrivate(fieldLigne.getModifiers())
				|| !Modifier.isPrivate(fieldMarquee.getModifiers())
				|| !Modifier.isPrivate(fieldCachee.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation les variables d'instance doivent etre declarees private");
			return 0;
		}
		if (!Reflexion.extendsClass(cCaseMinee, cCaseAbstraite)) {
			System.out.println("   Aie... CaseVide n'etends pas CaseAbstraite. CaseVide doit heriter de CaseAbstraite.");
			return 0;
		}
		Class[] arg2 = { ITerrainMine.class, int.class, int.class };
		Constructor const1=null;
		try {
			const1 = cCaseMinee.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
		//	e.printStackTrace();
			const1=null;
		} catch (SecurityException e) {
		//	e.printStackTrace();
			const1=null;
		}
		if (const1==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur CaseMinee(ITerrainMine terrain, int colonne, int ligne). Impossible de tester");
			return 0;
		}
		if (Modifier.isPrivate(const1.getModifiers())|| Modifier.isProtected(const1.getModifiers())) {
			System.out.println("   Aie... le constructeur de CaseMinee devrait etre public");
		}
		const1.setAccessible(true);
		fieldTerrain.setAccessible(true);
		fieldLigne.setAccessible(true);
		fieldColonne.setAccessible(true);
		fieldCachee.setAccessible(true);
		fieldMarquee.setAccessible(true);
		Object[][] args = { 
				{new TerrainMine(10,8,4), Integer.valueOf(9), Integer.valueOf(7)},
				{new TerrainMine(10,8,4), Integer.valueOf(2), Integer.valueOf(4)},
				{new TerrainMine(10,8,4), Integer.valueOf(5), Integer.valueOf(3)},
				};

		for (int i=0; i<args.length; i++) {
			Object pt1=null;
			ITerrainMine resTerrain=null;
			int resColonne=0;
			int resLigne=0;
			boolean resMarquee=true;
			boolean resCachee=false;
			try {
				pt1 = (const1.newInstance(args[i]));
				resTerrain = (ITerrainMine)(fieldTerrain.get(pt1));
				if (resTerrain!=(ITerrainMine)args[i][0]) {
					System.out.println("   Aie... le constructeur de CaseMinee n'initialise pas convenablement le terrain\n");
					return 0;
				}
				resColonne = (int)(fieldColonne.get(pt1));
				if (resColonne!=(int)args[i][1]) {
					System.out.println("   Aie... le constructeur de CaseMinee n'initialise pas convenablement la colonne\n");
					return 0;
				}
				resLigne = (int)(fieldLigne.get(pt1));
				if (resLigne!=(int)args[i][2]) {
					System.out.println("   Aie... le constructeur de CaseMinee n'initialise pas convenablement la lignee\n");
					return 0;
				}
				resMarquee = (boolean)(fieldMarquee.get(pt1));
				if (resMarquee) {
					System.out.println("   Aie... le constructeur de CaseMinee n'initialise pas convenablement marquee\n");
					return 0;
				}
				resCachee = (boolean)(fieldCachee.get(pt1));
				if (!resCachee) {
					System.out.println("   Aie... le constructeur de CaseMinee n'initialise pas convenablement cachee\n");
					return 0;
				}
			} catch (Exception e) {
				if (e instanceof InvocationTargetException) {
					e.getCause().printStackTrace();
				} else {
					e.printStackTrace();
				}
				return 0;
			}
		}
		String[] argss={"ITerrainMine", "int", "int"};
		String co = Reflexion.constructeurNomFic("src"+File.separator+"s05"+File.separator+"demineur"+File.separator+"CaseMinee.java", "CaseMinee", argss);
		co=Reflexion.sansEspacesAvantParentheses(co);
		//System.out.println(">>>"+co+"<<<");
		if ( !co.contains("super(")) {
			System.out.println("   Aie... Le constructeur de CaseMinee ne fait pas appel au constructeur de sa super-classe");
			return 0;
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}




	
	
	



	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test05CaseMineeGetValeur() {
		Class cICase = Reflexion.getClass("s05.demineur.ICase");
		if (cICase==null) {
			System.out.println("   Aie... je ne trouve pas l'interface ICase dans le package demineur");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cCaseAbstraite= Reflexion.getClass("s05.demineur.CaseAbstraite");
		if (cCaseAbstraite==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseAbstraite dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseMinee= Reflexion.getClass("s05.demineur.CaseMinee");
		if (cCaseMinee==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseMinee dans le package demineur. Impossible de tester");
			return 0;
		}
		Field fieldTerrain=null, fieldColonne=null, fieldLigne=null, fieldMarquee=null, fieldCachee=null, fieldOther=null;
		Field[] tf = cCaseAbstraite.getDeclaredFields();
		//int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {
			//	nbv++;
			}
			if ( f.getType().equals(ITerrainMine.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldTerrain==null) {
					fieldTerrain=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("col")) {
				if (fieldColonne==null) {
					fieldColonne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("lig")) {
				if (fieldLigne==null) {
					fieldLigne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("mar")) {
				if (fieldMarquee==null) {
					fieldMarquee=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("mar")) {
				if (fieldCachee==null) {
					fieldCachee=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldTerrain==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance referencant le terrain.");
			return 0;
		}
		if (fieldColonne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la colonne.");
			return 0;
		}
		if (fieldLigne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la ligne.");
			return 0;
		}
		if (fieldMarquee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est marquee.");
			return 0;
		}
		if (fieldCachee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est cachee.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Vous n'avez pas a ajouter de variables dans la classe CaseAbstraite");
			return 0;
		}
		if (!Reflexion.implementsInterface(cCaseAbstraite, cICase)) {
			System.out.println("   Aie... La classe CaseAbstraite n'implemente pas l'interface ICase.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldTerrain.getModifiers())
				|| !Modifier.isPrivate(fieldColonne.getModifiers())
				|| !Modifier.isPrivate(fieldLigne.getModifiers())
				|| !Modifier.isPrivate(fieldMarquee.getModifiers())
				|| !Modifier.isPrivate(fieldCachee.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation les variables d'instance doivent etre declarees private");
			return 0;
		}
		if (!Reflexion.extendsClass(cCaseMinee, cCaseAbstraite)) {
			System.out.println("   Aie... CaseVide n'etends pas CaseAbstraite. CaseVide doit heriter de CaseAbstraite.");
			return 0;
		}
		Class[] arg2 = { ITerrainMine.class, int.class, int.class };
		Constructor const1=null;
		try {
			const1 = cCaseMinee.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
		//	e.printStackTrace();
			const1=null;
		} catch (SecurityException e) {
		//	e.printStackTrace();
			const1=null;
		}
		if (const1==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur CaseMinee(ITerrainMine terrain, int colonne, int ligne). Impossible de tester");
			return 0;
		}
		if (Modifier.isPrivate(const1.getModifiers())|| Modifier.isProtected(const1.getModifiers())) {
			System.out.println("   Aie... le constructeur de CaseMinee devrait etre public");
		}
		const1.setAccessible(true);
		fieldTerrain.setAccessible(true);
		fieldLigne.setAccessible(true);
		fieldColonne.setAccessible(true);
		fieldCachee.setAccessible(true);
		fieldMarquee.setAccessible(true);
		Object[][] args = { 
				{new TerrainMine(10,8,4), Integer.valueOf(9), Integer.valueOf(7)},
				{new TerrainMine(10,8,4), Integer.valueOf(2), Integer.valueOf(4)},
				{new TerrainMine(10,8,4), Integer.valueOf(5), Integer.valueOf(3)},
				};

		Class[] ar = {};
		Method mGetValeur=null;
		try {
			mGetValeur = cCaseMinee.getDeclaredMethod("getValeur", ar);
		} catch (NoSuchMethodException e1) {
		//	e1.printStackTrace();
			mGetValeur=null;
		} catch (SecurityException e1) {
		//	e1.printStackTrace();
			mGetValeur=null;
		}
		if (mGetValeur==null) {
			System.out.println("   Aie... je ne trouve pas la methode getValeur() dans la classe CaseMinee()");
			return 0;
		}
		Object[] paramb= {};

		for (int i=0; i<args.length; i++) {
			Object pt1=null;
			int res=-1;
			try {
				pt1 = (const1.newInstance(args[i]));
				fieldTerrain.set(pt1, args[i][0]);
				fieldColonne.set(pt1, args[i][1]);
				fieldLigne.set(pt1, args[i][2]);
				fieldCachee.set(pt1, Boolean.valueOf(true));
				fieldMarquee.set(pt1, Boolean.valueOf(false));
				res = (int)(mGetValeur.invoke(pt1, paramb));
				if (res!=ICase.MINEE) {
					System.out.println("   Aie... getValeur() de CaseMinee doit toujours retourner ICase.MINEE ce qui n'est pas le cas de votre implementation");
					return 0;
				}
			} catch (Exception e) {
				if (e instanceof InvocationTargetException) {
					e.getCause().printStackTrace();
				} else {
					e.printStackTrace();
				}
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}




	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test06CaseMineeEstMinee() {
		Class cICase = Reflexion.getClass("s05.demineur.ICase");
		if (cICase==null) {
			System.out.println("   Aie... je ne trouve pas l'interface ICase dans le package demineur");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cCaseAbstraite= Reflexion.getClass("s05.demineur.CaseAbstraite");
		if (cCaseAbstraite==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseAbstraite dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseMinee= Reflexion.getClass("s05.demineur.CaseMinee");
		if (cCaseMinee==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseMinee dans le package demineur. Impossible de tester");
			return 0;
		}
		Field fieldTerrain=null, fieldColonne=null, fieldLigne=null, fieldMarquee=null, fieldCachee=null, fieldOther=null;
		Field[] tf = cCaseAbstraite.getDeclaredFields();
		//int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {
			//	nbv++;
			}
			if ( f.getType().equals(ITerrainMine.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldTerrain==null) {
					fieldTerrain=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("col")) {
				if (fieldColonne==null) {
					fieldColonne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("lig")) {
				if (fieldLigne==null) {
					fieldLigne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("mar")) {
				if (fieldMarquee==null) {
					fieldMarquee=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("mar")) {
				if (fieldCachee==null) {
					fieldCachee=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldTerrain==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance referencant le terrain.");
			return 0;
		}
		if (fieldColonne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la colonne.");
			return 0;
		}
		if (fieldLigne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la ligne.");
			return 0;
		}
		if (fieldMarquee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est marquee.");
			return 0;
		}
		if (fieldCachee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est cachee.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Vous n'avez pas a ajouter de variables dans la classe CaseAbstraite");
			return 0;
		}
		if (!Reflexion.implementsInterface(cCaseAbstraite, cICase)) {
			System.out.println("   Aie... La classe CaseAbstraite n'implemente pas l'interface ICase.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldTerrain.getModifiers())
				|| !Modifier.isPrivate(fieldColonne.getModifiers())
				|| !Modifier.isPrivate(fieldLigne.getModifiers())
				|| !Modifier.isPrivate(fieldMarquee.getModifiers())
				|| !Modifier.isPrivate(fieldCachee.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation les variables d'instance doivent etre declarees private");
			return 0;
		}
		if (!Reflexion.extendsClass(cCaseMinee, cCaseAbstraite)) {
			System.out.println("   Aie... CaseVide n'etends pas CaseAbstraite. CaseVide doit heriter de CaseAbstraite.");
			return 0;
		}
		Class[] arg2 = { ITerrainMine.class, int.class, int.class };
		Constructor const1=null;
		try {
			const1 = cCaseMinee.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
		//	e.printStackTrace();
			const1=null;
		} catch (SecurityException e) {
		//	e.printStackTrace();
			const1=null;
		}
		if (const1==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur CaseMinee(ITerrainMine terrain, int colonne, int ligne). Impossible de tester");
			return 0;
		}
		if (Modifier.isPrivate(const1.getModifiers())|| Modifier.isProtected(const1.getModifiers())) {
			System.out.println("   Aie... le constructeur de CaseMinee devrait etre public");
		}
		const1.setAccessible(true);
		fieldTerrain.setAccessible(true);
		fieldLigne.setAccessible(true);
		fieldColonne.setAccessible(true);
		fieldCachee.setAccessible(true);
		fieldMarquee.setAccessible(true);
		Object[][] args = { 
				{new TerrainMine(10,8,4), Integer.valueOf(9), Integer.valueOf(7)},
				{new TerrainMine(10,8,4), Integer.valueOf(2), Integer.valueOf(4)},
				{new TerrainMine(10,8,4), Integer.valueOf(5), Integer.valueOf(3)},
				};

		Class[] ar = {};
		Method mEstMinee=null;
		try {
			mEstMinee = cCaseMinee.getDeclaredMethod("estMinee", ar);
		} catch (NoSuchMethodException e1) {
		//	e1.printStackTrace();
			mEstMinee=null;
		} catch (SecurityException e1) {
		//	e1.printStackTrace();
			mEstMinee=null;
		}
		if (mEstMinee==null) {
			System.out.println("   Aie... je ne trouve pas la methode estMinee() dans la classe CaseMinee()");
			return 0;
		}
		Object[] paramb= {};

		for (int i=0; i<args.length; i++) {
			Object pt1=null;
			boolean res=false;
			try {
				pt1 = (const1.newInstance(args[i]));
				fieldTerrain.set(pt1, args[i][0]);
				fieldColonne.set(pt1, args[i][1]);
				fieldLigne.set(pt1, args[i][2]);
				fieldCachee.set(pt1, Boolean.valueOf(true));
				fieldMarquee.set(pt1, Boolean.valueOf(false));
				res = (boolean)(mEstMinee.invoke(pt1, paramb));
				if (!res) {
					System.out.println("   Aie... estMinee() de CaseMinee doit toujours retourner true ce qui n'est pas le cas de votre implementation");
					return 0;
				}
			} catch (Exception e) {
				if (e instanceof InvocationTargetException) {
					e.getCause().printStackTrace();
				} else {
					e.printStackTrace();
				}
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}
	
	
	
	
	



	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test07CaseNumeroteeConstructeur() {
		Class cICase = Reflexion.getClass("s05.demineur.ICase");
		if (cICase==null) {
			System.out.println("   Aie... je ne trouve pas l'interface ICase dans le package demineur");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cCaseAbstraite= Reflexion.getClass("s05.demineur.CaseAbstraite");
		if (cCaseAbstraite==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseAbstraite dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseVide= Reflexion.getClass("s05.demineur.CaseVide");
		if (cCaseVide==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseVide dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseNumerotee= Reflexion.getClass("s05.demineur.CaseNumerotee");
		if (cCaseNumerotee==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseNumerotee dans le package demineur. Impossible de tester");
			return 0;
		}
		Field fieldTerrain=null, fieldColonne=null, fieldLigne=null, fieldMarquee=null, fieldCachee=null, fieldOther=null;
		Field[] tf = cCaseAbstraite.getDeclaredFields();
		//int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {
			//	nbv++;
			}
			if ( f.getType().equals(ITerrainMine.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldTerrain==null) {
					fieldTerrain=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("col")) {
				if (fieldColonne==null) {
					fieldColonne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("lig")) {
				if (fieldLigne==null) {
					fieldLigne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("mar")) {
				if (fieldMarquee==null) {
					fieldMarquee=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("mar")) {
				if (fieldCachee==null) {
					fieldCachee=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldTerrain==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance referencant le terrain.");
			return 0;
		}
		if (fieldColonne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la colonne.");
			return 0;
		}
		if (fieldLigne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la ligne.");
			return 0;
		}
		if (fieldMarquee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est marquee.");
			return 0;
		}
		if (fieldCachee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est cachee.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Vous n'avez pas a ajouter de variables dans la classe CaseAbstraite");
			return 0;
		}
		Field fieldValeur=null;
		tf = cCaseNumerotee.getDeclaredFields();
		
		
		
		
		for (Field f : tf) {
			//System.out.println("f="+f.getName());
			if (!Modifier.isStatic(f.getModifiers())) {
			//	nbv++;
			}
			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldValeur==null) {
					fieldValeur=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldValeur==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseNumerotee la variable d'instance memorisant la valeur de la case.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Seule la variable memorisant la valeur de la case doit etre declaree dans CaseNumerotee");
			return 0;
		}
		if (!Reflexion.extendsClass(cCaseNumerotee, cCaseVide)) {
			System.out.println("   Aie... La classe CaseNumerotee n'etends pas CaseVide.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldValeur.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation les variables d'instance doivent etre declarees private");
			return 0;
		}

		Class[] arg2 = { ITerrainMine.class, int.class, int.class, int.class };
		Constructor const1=null;
		try {
			const1 = cCaseNumerotee.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
		//	e.printStackTrace();
			const1=null;
		} catch (SecurityException e) {
		//	e.printStackTrace();
			const1=null;
		}
		if (const1==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur CaseNumerotee(ITerrainMine terrain, int colonne, int ligne, int valeur). Impossible de tester");
			return 0;
		}
		if (Modifier.isPrivate(const1.getModifiers())|| Modifier.isProtected(const1.getModifiers())) {
			System.out.println("   Aie... le constructeur de CaseNumerotee devrait etre public");
		}
		const1.setAccessible(true);
		fieldTerrain.setAccessible(true);
		fieldLigne.setAccessible(true);
		fieldColonne.setAccessible(true);
		fieldCachee.setAccessible(true);
		fieldMarquee.setAccessible(true);
		fieldValeur.setAccessible(true);
		Object[][] args = { 
				{new TerrainMine(10,8,4), Integer.valueOf(9), Integer.valueOf(7), Integer.valueOf(2)},
				{new TerrainMine(10,8,4), Integer.valueOf(2), Integer.valueOf(4), Integer.valueOf(4)},
				{new TerrainMine(10,8,4), Integer.valueOf(5), Integer.valueOf(3), Integer.valueOf(8)},
				};

		for (int i=0; i<args.length; i++) {
			Object pt1=null;
			ITerrainMine resTerrain=null;
			int resColonne=0;
			int resLigne=0;
			boolean resMarquee=true;
			boolean resCachee=false;
			int resValeur=-1;
			try {
				pt1 = (const1.newInstance(args[i]));
				resTerrain = (ITerrainMine)(fieldTerrain.get(pt1));
				if (resTerrain!=(ITerrainMine)args[i][0]) {
					System.out.println("   Aie... le constructeur de CaseMinee n'initialise pas convenablement le terrain\n");
					return 0;
				}
				resColonne = (int)(fieldColonne.get(pt1));
				if (resColonne!=(int)args[i][1]) {
					System.out.println("   Aie... le constructeur de CaseNumerotee n'initialise pas convenablement la colonne\n");
					return 0;
				}
				resLigne = (int)(fieldLigne.get(pt1));
				if (resLigne!=(int)args[i][2]) {
					System.out.println("   Aie... le constructeur de CaseNumerotee n'initialise pas convenablement la lignee\n");
					return 0;
				}
				resMarquee = (boolean)(fieldMarquee.get(pt1));
				if (resMarquee) {
					System.out.println("   Aie... le constructeur de CaseNumerotee n'initialise pas convenablement marquee\n");
					return 0;
				}
				resCachee = (boolean)(fieldCachee.get(pt1));
				if (!resCachee) {
					System.out.println("   Aie... le constructeur de CaseNumerotee n'initialise pas convenablement cachee\n");
					return 0;
				}
				resValeur = (int)(fieldValeur.get(pt1));
				if (resValeur!=(int)args[i][3]) {
					System.out.println("   Aie... le constructeur de CaseNumerotee n'initialise pas convenablement la valeur\n");
					return 0;
				}
			} catch (Exception e) {
				if (e instanceof InvocationTargetException) {
					e.getCause().printStackTrace();
				} else {
					e.printStackTrace();
				}
				return 0;
			}
		}
		String[] argss={"ITerrainMine", "int", "int", "int"};
		String co = Reflexion.constructeurNomFic("src"+File.separator+"s05"+File.separator+"demineur"+File.separator+"CaseNumerotee.java", "CaseNumerotee", argss);
		co=Reflexion.sansEspacesAvantParentheses(co);
		//System.out.println(">>>"+co+"<<<");
		if ( !co.contains("super(")) {
			System.out.println("   Aie... Le constructeur de CaseMinee ne fait pas appel au constructeur de sa super-classe");
			return 0;
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}




	
	
	


	
	



	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test08CaseNumeroteeGetValeur() {
		Class cICase = Reflexion.getClass("s05.demineur.ICase");
		if (cICase==null) {
			System.out.println("   Aie... je ne trouve pas l'interface ICase dans le package demineur");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cCaseAbstraite= Reflexion.getClass("s05.demineur.CaseAbstraite");
		if (cCaseAbstraite==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseAbstraite dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseVide= Reflexion.getClass("s05.demineur.CaseVide");
		if (cCaseVide==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseVide dans le package demineur. Impossible de tester");
			return 0;
		}
		Class cCaseNumerotee= Reflexion.getClass("s05.demineur.CaseNumerotee");
		if (cCaseNumerotee==null) {
			System.out.println("   Aie... je ne trouve pas la classe CaseNumerotee dans le package demineur. Impossible de tester");
			return 0;
		}
		Field fieldTerrain=null, fieldColonne=null, fieldLigne=null, fieldMarquee=null, fieldCachee=null, fieldOther=null;
		Field[] tf = cCaseAbstraite.getDeclaredFields();
		//int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {
			//	nbv++;
			}
			if ( f.getType().equals(ITerrainMine.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldTerrain==null) {
					fieldTerrain=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("col")) {
				if (fieldColonne==null) {
					fieldColonne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("lig")) {
				if (fieldLigne==null) {
					fieldLigne=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("mar")) {
				if (fieldMarquee==null) {
					fieldMarquee=f;
				} else {
					fieldOther=f;
				}
			} else if ( f.getType().equals(boolean.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("mar")) {
				if (fieldCachee==null) {
					fieldCachee=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldTerrain==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance referencant le terrain.");
			return 0;
		}
		if (fieldColonne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la colonne.");
			return 0;
		}
		if (fieldLigne==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance correspondant a la ligne.");
			return 0;
		}
		if (fieldMarquee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est marquee.");
			return 0;
		}
		if (fieldCachee==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseAbstraite la variable d'instance memorisant si la case est cachee.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Vous n'avez pas a ajouter de variables dans la classe CaseAbstraite");
			return 0;
		}
		Field fieldValeur=null;
		tf = cCaseNumerotee.getDeclaredFields();
		
		
		
		
		for (Field f : tf) {
			//System.out.println("f="+f.getName());
			if (!Modifier.isStatic(f.getModifiers())) {
			//	nbv++;
			}
			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
				if (fieldValeur==null) {
					fieldValeur=f;
				} else {
					fieldOther=f;
				}
			} else if (!Modifier.isStatic(f.getModifiers())) {
				fieldOther=f;
			}
		}
		if (fieldValeur==null) {
			System.out.println("   Aie... Je ne trouve pas dans CaseNumerotee la variable d'instance memorisant la valeur de la case.");
			return 0;
		}
		if (fieldOther!=null) {
			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". Seule la variable memorisant la valeur de la case doit etre declaree dans CaseNumerotee");
			return 0;
		}
		if (!Reflexion.extendsClass(cCaseNumerotee, cCaseVide)) {
			System.out.println("   Aie... La classe CaseNumerotee n'etends pas CaseVide.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldValeur.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation les variables d'instance doivent etre declarees private");
			return 0;
		}

		Class[] arg2 = { ITerrainMine.class, int.class, int.class, int.class };
		Constructor const1=null;
		try {
			const1 = cCaseNumerotee.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
		//	e.printStackTrace();
			const1=null;
		} catch (SecurityException e) {
		//	e.printStackTrace();
			const1=null;
		}
		if (const1==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur CaseNumerotee(ITerrainMine terrain, int colonne, int ligne, int valeur). Impossible de tester");
			return 0;
		}
		if (Modifier.isPrivate(const1.getModifiers())|| Modifier.isProtected(const1.getModifiers())) {
			System.out.println("   Aie... le constructeur de CaseNumerotee devrait etre public");
		}
		const1.setAccessible(true);
		fieldTerrain.setAccessible(true);
		fieldLigne.setAccessible(true);
		fieldColonne.setAccessible(true);
		fieldCachee.setAccessible(true);
		fieldMarquee.setAccessible(true);
		fieldValeur.setAccessible(true);
		Object[][] args = { 
				{new TerrainMine(10,8,4), Integer.valueOf(9), Integer.valueOf(7), Integer.valueOf(2)},
				{new TerrainMine(10,8,4), Integer.valueOf(2), Integer.valueOf(4), Integer.valueOf(4)},
				{new TerrainMine(10,8,4), Integer.valueOf(5), Integer.valueOf(3), Integer.valueOf(8)},
				};


		Class[] ar = {};
		Method mGetValeur=null;
		try {
			mGetValeur = cCaseNumerotee.getDeclaredMethod("getValeur", ar);
		} catch (NoSuchMethodException e1) {
		//	e1.printStackTrace();
			mGetValeur=null;
		} catch (SecurityException e1) {
		//	e1.printStackTrace();
			mGetValeur=null;
		}
		if (mGetValeur==null) {
			System.out.println("   Aie... je ne trouve pas la methode getValeur() dans la classe CaseNumerotee()");
			return 0;
		}
		Object[] paramb= {};

		for (int i=0; i<args.length; i++) {
			Object pt1=null;
			int res=-1;
			try {
				pt1 = (const1.newInstance(args[i]));
				fieldTerrain.set(pt1, args[i][0]);
				fieldColonne.set(pt1, args[i][1]);
				fieldLigne.set(pt1, args[i][2]);
				fieldValeur.set(pt1, args[i][3]);
				fieldCachee.set(pt1, Boolean.valueOf(true));
				fieldMarquee.set(pt1, Boolean.valueOf(false));
				res = (int)(mGetValeur.invoke(pt1, paramb));
				if (res!=(int)(args[i][3])) {
					System.out.println("   Aie... getValeur() de CaseNumerotee n'a pas retourne la valeur de la case");
					return 0;
				}
			} catch (Exception e) {
				if (e instanceof InvocationTargetException) {
					e.getCause().printStackTrace();
				} else {
					e.printStackTrace();
				}
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}




	
	
	



//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test02CompteurNonBorneConstructeurSansParam() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurNonBorne.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... Je ne trouve pas dans CompteurNonBorne la variable d'instance correspondant a la valeur entiere du compteur.");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". La seule variable d'instance de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurNonBorne alors qu'il ne devrait y en avoir qu'une (pour memoriser la valeur du compteur)");
//			return 0;
//		}
//		/*	if (!Reflexion.implementsInterface(cCompteurNonBorne, cICompteur)) {
//			System.out.println("   Aie... La classe Carre n'implemente pas l'interface IForme.");
//			System.out.println("          Veillez a completer la declaration de Carre de sorte qu'elle implemente IForme");
//			return 0;
//		}//*/
//		if (!Modifier.isPrivate(fieldValeur.getModifiers())) {
//			System.out.println("   Aie... pour respecter le principe d'encapsulation la variable d'instance "+fieldValeur.getName()+" de CompteurNonBorne devrait etre declaree private");
//			return 0;
//		}
//		Class[] arg2 = {};// int.class };
//		Constructor const0=null;
//		try {
//			const0 = cCompteurNonBorne.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur CompteurNonBorne(). Impossible de tester");
//			return 0;
//		}
//		if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}
//		const0.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		/*	Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//		 */
//		Object[] param = {};
//		//for (int i=0; i<args.length; i++) {
//		Object pt1=null;
//		int res=0;
//		try {
//			pt1 = (const0.newInstance(param));//args[i]));
//			res = (int)(fieldValeur.get(pt1));
//			if (res!=0) {//(int)args[i][0]) {
//				System.out.println("   Aie... apres c = new CompteNonBorne() c."+fieldValeur.getName()+" a pour valeur "+res+" au lieu de 0.\n");
//				return 0;
//			}
//		} catch (Exception e) {
//			if (e instanceof InvocationTargetException) {
//				e.getCause().printStackTrace();
//			} else {
//				e.printStackTrace();
//			}
//			return 0;
//		}
//		//}
//		String[] argss={};
//		String co = Reflexion.constructeurNomFic("src"+File.separator+"s05"+File.separator+"compteurs"+File.separator+"CompteurNonBorne.java", "CompteurNonBorne", argss);
//		co=Reflexion.sansEspacesAvantParentheses(co);
//		//System.out.println(">>>"+co+"<<<");
//		if (!co.contains("this(")) {
//			System.out.println("   Aie... Votre constructeur CompteurNonBorne() doit operer PAR CHAINAGE");
//			return 0;
//		}
//
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test03CompteurNonBorneInterfaceICompteur() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurNonBorne.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... Je ne trouve pas dans CompteurNonBorne la variable d'instance correspondant a la valeur entiere du compteur.");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". La seule variable d'instance de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurNonBorne alors qu'il ne devrait y en avoir qu'une (pour memoriser la valeur du compteur)");
//			return 0;
//		}
//		if (!Reflexion.implementsInterface(cCompteurNonBorne, cICompteur)) {
//			System.out.println("   Aie... La classe CompteurNonBorne n'implemente pas l'interface ICompteur.");
//			return 0;
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test04CompteurNonBorneGetValeur() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurNonBorne.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... Je ne trouve pas dans CompteurNonBorne la variable d'instance correspondant a la valeur entiere du compteur.");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". La seule variable d'instance de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurNonBorne alors qu'il ne devrait y en avoir qu'une (pour memoriser la valeur du compteur)");
//			return 0;
//		}
//		/*if (!Reflexion.implementsInterface(cCompteurNonBorne, cICompteur)) {
//			System.out.println("   Aie... La classe CompteurNonBorne n'implemente pas l'interface ICompteur.");
//			return 0;
//		}*/
//		/*if (!Modifier.isPrivate(fieldValeur.getModifiers())) {
//			System.out.println("   Aie... pour respecter le principe d'encapsulation la variable d'instance "+fieldValeur.getName()+" de CompteurNonBorne devrait etre declaree private");
//			return 0;
//		}*/
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurNonBorne.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurNonBorne.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurNonBorne(int) ni le constructeur CompteurNonBorne(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};
//		Method mGetValeur=null;
//		try {
//			mGetValeur = cCompteurNonBorne.getDeclaredMethod("getValeur", ar);
//		} catch (NoSuchMethodException e1) {
//			e1.printStackTrace();
//			mGetValeur=null;
//		} catch (SecurityException e1) {
//			e1.printStackTrace();
//			mGetValeur=null;
//		}
//		if (mGetValeur==null) {
//			System.out.println("   Aie... je ne trouve pas la methode getValeur() dans la classe CompteurNonBorne");
//			return 0;
//		}
//
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			int res=0;
//			try {
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				res = (int)(mGetValeur.invoke(pt1, paramb));
//				if (res!=(int)args[i][0]) {
//					System.out.println("   Aie... sur un CompteNonBorne ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" getValeur() retourne "+res+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}		
//				return 0;
//			}
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test05CompteurNonBorneInc() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurNonBorne.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... Je ne trouve pas dans CompteurNonBorne la variable d'instance correspondant a la valeur entiere du compteur.");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". La seule variable d'instance de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurNonBorne alors qu'il ne devrait y en avoir qu'une (pour memoriser la valeur du compteur)");
//			return 0;
//		}
//		/*if (!Reflexion.implementsInterface(cCompteurNonBorne, cICompteur)) {
//			System.out.println("   Aie... La classe CompteurNonBorne n'implemente pas l'interface ICompteur.");
//			return 0;
//		}*/
//		/*if (!Modifier.isPrivate(fieldValeur.getModifiers())) {
//			System.out.println("   Aie... pour respecter le principe d'encapsulation la variable d'instance "+fieldValeur.getName()+" de CompteurNonBorne devrait etre declaree private");
//			return 0;
//		}*/
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurNonBorne.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurNonBorne.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurNonBorne(int) ni le constructeur CompteurNonBorne(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};
//		Method mInc=null;
//		try {
//			mInc = cCompteurNonBorne.getDeclaredMethod("inc", ar);
//		} catch (NoSuchMethodException e1) {
//			e1.printStackTrace();
//			mInc=null;
//		} catch (SecurityException e1) {
//			e1.printStackTrace();
//			mInc=null;
//		}
//		if (mInc==null) {
//			System.out.println("   Aie... je ne trouve pas la methode inc() dans la classe CompteurNonBorne");
//			return 0;
//		}
//
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			int res=0;
//			try {
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				//res = (int)(
//				mInc.invoke(pt1, paramb);
//				res = (int)fieldValeur.get(pt1);
//				if (res!=(int)args[i][0]+1) {
//					System.out.println("   Aie... sur un CompteNonBorne ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" apres l'appel a inc() c."+fieldValeur.getName()+" vaut "+res+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test06CompteurNonBorneDec() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurNonBorne.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... Je ne trouve pas dans CompteurNonBorne la variable d'instance correspondant a la valeur entiere du compteur.");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". La seule variable d'instance de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurNonBorne alors qu'il ne devrait y en avoir qu'une (pour memoriser la valeur du compteur)");
//			return 0;
//		}
//		/*if (!Reflexion.implementsInterface(cCompteurNonBorne, cICompteur)) {
//			System.out.println("   Aie... La classe CompteurNonBorne n'implemente pas l'interface ICompteur.");
//			return 0;
//		}*/
//		/*if (!Modifier.isPrivate(fieldValeur.getModifiers())) {
//			System.out.println("   Aie... pour respecter le principe d'encapsulation la variable d'instance "+fieldValeur.getName()+" de CompteurNonBorne devrait etre declaree private");
//			return 0;
//		}*/
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurNonBorne.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurNonBorne.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurNonBorne(int) ni le constructeur CompteurNonBorne(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};
//		Method mDec=null;
//		try {
//			mDec = cCompteurNonBorne.getDeclaredMethod("dec", ar);
//		} catch (NoSuchMethodException e1) {
//			e1.printStackTrace();
//			mDec=null;
//		} catch (SecurityException e1) {
//			e1.printStackTrace();
//			mDec=null;
//		}
//		if (mDec==null) {
//			System.out.println("   Aie... je ne trouve pas la methode dec() dans la classe CompteurNonBorne");
//			return 0;
//		}
//
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			int res=0;
//			try {
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				//res = (int)(
//				mDec.invoke(pt1, paramb);
//				res = (int)fieldValeur.get(pt1);
//				if (res!=(int)args[i][0]-1) {
//					System.out.println("   Aie... sur un CompteNonBorne ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" apres l'appel a dec() c."+fieldValeur.getName()+" vaut "+res+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test07CompteurNonBorneEquals() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurNonBorne.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... Je ne trouve pas dans CompteurNonBorne la variable d'instance correspondant a la valeur entiere du compteur.");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". La seule variable d'instance de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurNonBorne alors qu'il ne devrait y en avoir qu'une (pour memoriser la valeur du compteur)");
//			return 0;
//		}
//		/*if (!Reflexion.implementsInterface(cCompteurNonBorne, cICompteur)) {
//			System.out.println("   Aie... La classe CompteurNonBorne n'implemente pas l'interface ICompteur.");
//			return 0;
//		}*/
//		/*if (!Modifier.isPrivate(fieldValeur.getModifiers())) {
//			System.out.println("   Aie... pour respecter le principe d'encapsulation la variable d'instance "+fieldValeur.getName()+" de CompteurNonBorne devrait etre declaree private");
//			return 0;
//		}*/
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurNonBorne.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurNonBorne.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurNonBorne(int) ni le constructeur CompteurNonBorne(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {Object.class};
//		Method mEquals=null;
//		try {
//			mEquals = cCompteurNonBorne.getDeclaredMethod("equals", ar);
//		} catch (NoSuchMethodException e1) {
//			e1.printStackTrace();
//			mEquals=null;
//		} catch (SecurityException e1) {
//			e1.printStackTrace();
//			mEquals=null;
//		}
//		if (mEquals==null) {
//			System.out.println("   Aie... je ne trouve pas la methode equals(Object) dans la classe CompteurNonBorne");
//			return 0;
//		}
//
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		Object[] paramEqual = new Object[1];
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			Object pt2=null;
//			boolean res=true;
//			try {
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				pt2 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				fieldValeur.set(pt2,  Integer.valueOf((Integer)args[i][0]));
//				//res = (int)(
//				paramEqual[0]=pt2;
//				res = (boolean)(mEquals.invoke(pt1, paramEqual));
//				if (!res) {
//					System.out.println("   Aie... sur un CompteNonBorne ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" c.equals(new CompteNonBloque("+(int)args[i][0]+")) retourne false.\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			Object pt2=null;
//			boolean res=true;
//			try {
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				pt2 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				fieldValeur.set(pt2,  Integer.valueOf((Integer)args[i][0]+2));
//				//res = (int)(
//				paramEqual[0]=pt2;
//				res = (boolean)(mEquals.invoke(pt1, paramEqual));
//				if (res) {
//					System.out.println("   Aie... sur un CompteNonBorne ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" c.equals(new CompteNonBloque("+((int)args[i][0]+2)+")) retourne true.\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				return 0;
//			}
//		}
//		Object pt1r=null;
//		//Object pt2=null;
//		boolean resr=true;
//		try {
//			pt1r = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//			//pt2 = new CNBR((Integer)args[i][0]);//const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//			fieldValeur.set(pt1r,  10);//args[i][0]);
//			//			fieldValeur.set(pt2,  Integer.valueOf((Integer)args[i][0]));
//			//res = (int)(
//			paramEqual[0]=null;
//			resr = (boolean)(mEquals.invoke(pt1r, paramEqual));
//			if (resr) {
//				System.out.println("   Aie... sur un CompteNonBorne c, c.equals(null) retourne true.\n");
//				return 50;
//			}
//		} catch (Exception e) {
//			if (e instanceof InvocationTargetException) {
//				e.getCause().printStackTrace();
//			} else {
//				e.printStackTrace();
//			}
//			return 50;
//		}
//
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			Object pt2=null;
//			boolean res=true;
//			try {
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				pt2 = new CNBR((Integer)args[i][0]);//const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				//				fieldValeur.set(pt2,  Integer.valueOf((Integer)args[i][0]));
//				//res = (int)(
//				paramEqual[0]=pt2;
//				res = (boolean)(mEquals.invoke(pt1, paramEqual));
//				if (!res) {
//					System.out.println("   Aie... sur un CompteNonBorne ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" c.equals(b) ou b est de type ICompteur (mais pas un CompteurNonBorne) de meme valeur, equals retourne false au lieu de true.\n");
//					return 75;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 75;
//			}
//		}
//		if (!Reflexion.respecteDeveloppementEnCouche("src"+File.separator+"s05"+File.separator+"compteurs"+File.separator+"CompteurNonBorne.java", cCompteurNonBorne, "equals(")) {
//			System.out.println("   Aie... la methode equals est un SERVICE : elle ne doit pas acceder directement aux variables d'instances afin de respecter le developpement en couches");
//			return 75;
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test08CompteurNonBorneToString() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurNonBorne.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... Je ne trouve pas dans CompteurNonBorne la variable d'instance correspondant a la valeur entiere du compteur.");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Vous avez defini la variable "+fieldOther.getName()+". La seule variable d'instance de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurNonBorne alors qu'il ne devrait y en avoir qu'une (pour memoriser la valeur du compteur)");
//			return 0;
//		}
//		/*if (!Reflexion.implementsInterface(cCompteurNonBorne, cICompteur)) {
//			System.out.println("   Aie... La classe CompteurNonBorne n'implemente pas l'interface ICompteur.");
//			return 0;
//		}*/
//		/*if (!Modifier.isPrivate(fieldValeur.getModifiers())) {
//			System.out.println("   Aie... pour respecter le principe d'encapsulation la variable d'instance "+fieldValeur.getName()+" de CompteurNonBorne devrait etre declaree private");
//			return 0;
//		}*/
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurNonBorne.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurNonBorne.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurNonBorne(int) ni le constructeur CompteurNonBorne(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};//Object.class};
//		Method mToString=null;
//		try {
//			mToString = cCompteurNonBorne.getDeclaredMethod("toString", ar);
//		} catch (NoSuchMethodException e1) {
//			e1.printStackTrace();
//			mToString=null;
//		} catch (SecurityException e1) {
//			e1.printStackTrace();
//			mToString=null;
//		}
//		if (mToString==null) {
//			System.out.println("   Aie... je ne trouve pas la methode toString() dans la classe CompteurNonBorne");
//			return 0;
//		}
//
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		//Object[] paramEqual = new Object[1];
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			//Object pt2=null;
//			String res="";
//			try {
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				//pt2 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				//fieldValeur.set(pt2,  Integer.valueOf((Integer)args[i][0]));
//				//res = (int)(
//				//paramEqual[0]=pt2;
//				res = (String)(mToString.invoke(pt1, paramb));//Equal));
//				if (!res.equals(args[i][0].toString())) {
//					System.out.println("   Aie... sur un CompteNonBorne ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" c.toString() retourne \""+res+"\" au lieu de \""+(int)args[i][0]+"\".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//
//		if (!Reflexion.respecteDeveloppementEnCouche("src"+File.separator+"s05"+File.separator+"compteurs"+File.separator+"CompteurNonBorne.java", cCompteurNonBorne, "toString(")) {
//			System.out.println("   Aie... la methode toString est un SERVICE : elle ne doit pas acceder directement aux variables d'instances afin de respecter le developpement en couches");
//			return 75;
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test09CompteurPositifSpecialise() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurPositif= Reflexion.getClass("s05.compteurs.CompteurPositif");
//		if (cCompteurPositif==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurPositif dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurPositif, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurPositif n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurPositif.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//		}
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=0) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurPositif alors que cette classe ne devrait pas comporter d'autres variables d'instances que celle heritee");
//			return 0;
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurPositif n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurPositif dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test10CompteurPositifConstructeur1Param() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurPositif= Reflexion.getClass("s05.compteurs.CompteurPositif");
//		if (cCompteurPositif==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurPositif dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurPositif, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurPositif n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurPositif.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//		}
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=0) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurPositif alors que cette classe ne devrait pas comporter d'autres variables d'instances que celle heritee");
//			return 0;
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurPositif n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurPositif dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { int.class };
//		Constructor const1=null;
//		try {
//			const1 = cCompteurPositif.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			const1=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const1=null;
//		}
//		if (const1==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur CompteurPositif(int).");
//			return 0;
//		}
//		if (Modifier.isPrivate(const1.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurPositif(int) ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const1.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurPositif(int) ne devrait pas etre protected");
//			return 0;
//		}
//		const1.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//		int[] resultats = {1,2,3, 4, 5, 10, 30, 60, 421, 0, 0, 0};
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			int res=0;
//			try {
//				pt1 = (const1.newInstance(args[i]));
//				res = (int)(fieldValeur.get(pt1));
//				if (res!=resultats[i]) {
//					System.out.println("   Aie... apres c = new CompteurPositif( "+args[i][0]+")) c."+fieldValeur.getName()+" a pour valeur "+res+" au lieu de "+resultats[i]+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test11CompteurPositifConstructeurSansParam() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurPositif= Reflexion.getClass("s05.compteurs.CompteurPositif");
//		if (cCompteurPositif==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurPositif dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurPositif, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurPositif n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurPositif.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//		}
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=0) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurPositif alors que cette classe ne devrait pas comporter d'autres variables d'instances que celle heritee");
//			return 0;
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurPositif n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurPositif dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { };//int.class };
//		Constructor const0=null;
//		try {
//			const0 = cCompteurPositif.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur CompteurPositif().");
//			return 0;
//		}
//		if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurPositif() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurPositif() ne devrait pas etre protected");
//			return 0;
//		}
//		const0.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		Object[] param= {};
//		/*	Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//int[] resultats = {1,2,3, 4, 5, 10, 30, 60, 421, 0, 0, 0};*/
//		//	for (int i=0; i<args.length; i++) {
//		Object pt1=null;
//		int res=0;
//		try {
//			pt1 = (const0.newInstance(param));//args[i]));
//			res = (int)(fieldValeur.get(pt1));
//			if (res!=0) {
//				System.out.println("   Aie... apres c = new CompteurPositif() c."+fieldValeur.getName()+" a pour valeur "+res+" au lieu de 0.\n");
//				return 0;
//			}
//		} catch (Exception e) {
//			if (e instanceof InvocationTargetException) {
//				e.getCause().printStackTrace();
//			} else {
//				e.printStackTrace();
//			}
//			return 0;
//		}
//		//	}
//		String[] argss={};
//		String co = Reflexion.constructeurNomFic("src"+File.separator+"s05"+File.separator+"compteurs"+File.separator+"CompteurPositif.java", "CompteurPositif", argss);
//		co=Reflexion.sansEspacesAvantParentheses(co);
//		//System.out.println(">>>"+co+"<<<");
//		if (!co.contains("this(") && !co.contains("super(")) {
//			System.out.println("   Aie... Votre constructeur CompteurPositif() doit operer PAR CHAINAGE");
//			return 0;
//		}
//
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test12CompteurPositifMethodesRedefinies() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurPositif= Reflexion.getClass("s05.compteurs.CompteurPositif");
//		if (cCompteurPositif==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurPositif dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurPositif, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurPositif n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null,  fieldOther=null;
//		Field[] tf = cCompteurPositif.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//		}
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=0) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurPositif alors que cette classe ne devrait pas comporter d'autres variables d'instances que celle heritee");
//			return 0;
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurPositif n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurPositif dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurPositif.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurPositif.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurPositif(int) ni le constructeur CompteurPositif(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};
//		Class[] aro = {Object.class};
//		Method mDec=null, mInc=null, mEquals=null, mToString=null, mGetValeur=null;
//		try {
//			mDec = cCompteurPositif.getDeclaredMethod("dec", ar);
//		} catch (NoSuchMethodException e1) {
//			//			e1.printStackTrace();
//		} catch (SecurityException e1) {
//			//			e1.printStackTrace();
//		}
//		try {
//			mInc = cCompteurPositif.getDeclaredMethod("inc", ar);
//		} catch (Exception e1) {
//		} 
//		try {
//			mToString = cCompteurPositif.getDeclaredMethod("toString", ar);
//		} catch (Exception e1) {
//		} 
//		try {
//			mGetValeur = cCompteurPositif.getDeclaredMethod("getValeur", ar);
//		} catch (Exception e1) {
//		} 
//		try {
//			mEquals = cCompteurPositif.getDeclaredMethod("equals", aro);
//		} catch (Exception e1) {
//		} 
//		if (mDec==null) {
//			System.out.println("   Aie... vous ne redefinissez pas une methode qui devrait l'etre");
//			return 0;
//		}
//
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)}};
//		int[]resultats= {0,1,2,3,4,9,29,59,420};
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			int res=0;
//			try {
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				//res = (int)(
//				mDec.invoke(pt1, paramb);
//				res = (int)fieldValeur.get(pt1);
//				if (res!=resultats[i]) {
//					System.out.println("   Aie... sur un CompteurPositif ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" apres l'appel a dec() c."+fieldValeur.getName()+" vaut "+res+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		if (mInc!=null||mToString!=null||mGetValeur!=null||mEquals!=null) {
//			System.out.println("   Aie... vous redefinissez une/des methode(s) qui pourraient ne pas etre redefinies");
//			return 75;
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test13CompteurHistoriseSpecialise() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurHistorise= Reflexion.getClass("s05.compteurs.CompteurHistorise");
//		if (cCompteurHistorise==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurHistorise dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurHistorise, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurHistorise n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null, fieldHistorique=null,  fieldOther=null;
//		Field[] tf = cCompteurHistorise.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(List.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldHistorique==null) {
//					fieldHistorique=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldHistorique==null) {
//			System.out.println("   Aie... CompteurHistorise doit avoir une variable d'instance de type liste d'entiers afin de memoriser l'historique des valeurs prises par le compteur");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorique dispose de la variable "+fieldOther.getName()+". La seule variable d'instance declaree dans CompteurHistorise devrait etre l'historique");
//			return 0;
//		}
//
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurHistorise alors que cette classe ne devrait declarer que l'historique pour variable d'instance (en plus de celle heritee)");
//			return 0;
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurHistorise n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorise dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test14CompteurHistoriseConstructeur1Param() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurHistorise= Reflexion.getClass("s05.compteurs.CompteurHistorise");
//		if (cCompteurHistorise==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurHistorise dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurHistorise, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurHistorise n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null, fieldHistorique=null,  fieldOther=null;
//		Field[] tf = cCompteurHistorise.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(List.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldHistorique==null) {
//					fieldHistorique=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldHistorique==null) {
//			System.out.println("   Aie... CompteurHistorise doit avoir une variable d'instance de type liste d'entiers afin de memoriser l'historique des valeurs prises par le compteur");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorique dispose de la variable "+fieldOther.getName()+". La seule variable d'instance declaree dans CompteurHistorise devrait etre l'historique");
//			return 0;
//		}
//
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurHistorise alors que cette classe ne devrait declarer que l'historique pour variable d'instance (en plus de celle heritee)");
//			return 0;
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurHistorise n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorise dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { int.class };
//		Constructor const1=null;
//		try {
//			const1 = cCompteurHistorise.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			const1=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const1=null;
//		}
//		if (const1==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur CompteurHistorise(int).");
//			return 0;
//		}
//		if (Modifier.isPrivate(const1.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurHistorise(int) ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const1.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurHistorise(int) ne devrait pas etre protected");
//			return 0;
//		}
//		const1.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		fieldHistorique.setAccessible(true);
//		Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			int res=0;
//			List<Integer> l = null;
//			try {
//				pt1 = (const1.newInstance(args[i]));
//				res = (int)(fieldValeur.get(pt1));
//				if (res!=(int)args[i][0]) {
//					System.out.println("   Aie... apres c = new CompteurHistorise( "+args[i][0]+")) c."+fieldValeur.getName()+" a pour valeur "+res+" au lieu de "+(int)args[i][0]+".\n");
//					return 0;
//				}
//				l = (List<Integer>)(fieldHistorique.get(pt1));
//				if (l==null) {
//					System.out.println("   Aie... apres c = new CompteurHistorise( "+args[i][0]+")) c."+fieldHistorique.getName()+" a pour valeur null\n");
//					return 0;
//				}
//				if (l.size()!=1) {
//					System.out.println("   Aie... apres c = new CompteurHistorise( "+args[i][0]+")) c."+fieldHistorique.getName()+".size() vaut "+l.size()+" au lieu de 1\n");
//					return 0;
//				}
//				if (!l.get(0).equals((Integer)args[i][0])) {
//					System.out.println("   Aie... apres c = new CompteurHistorise( "+args[i][0]+")) c."+fieldHistorique.getName()+".get(0) vaut "+l.get(0)+" au lieu de "+(int)args[i][0]+"\n");
//					return 0;
//				}
//
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test15CompteurHistoriseConstructeurSansParam() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurHistorise= Reflexion.getClass("s05.compteurs.CompteurHistorise");
//		if (cCompteurHistorise==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurHistorise dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurHistorise, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurHistorise n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null, fieldHistorique=null,  fieldOther=null;
//		Field[] tf = cCompteurHistorise.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(List.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldHistorique==null) {
//					fieldHistorique=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldHistorique==null) {
//			System.out.println("   Aie... CompteurHistorise doit avoir une variable d'instance de type liste d'entiers afin de memoriser l'historique des valeurs prises par le compteur");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorique dispose de la variable "+fieldOther.getName()+". La seule variable d'instance declaree dans CompteurHistorise devrait etre l'historique");
//			return 0;
//		}
//
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurHistorise alors que cette classe ne devrait declarer que l'historique pour variable d'instance (en plus de celle heritee)");
//			return 0;
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurHistorise n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorise dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { };//int.class };
//		Constructor const0=null;
//		try {
//			const0 = cCompteurHistorise.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur CompteurHistorise().");
//			return 0;
//		}
//		if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurHistorise() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurHistorise() ne devrait pas etre protected");
//			return 0;
//		}
//		const0.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		fieldHistorique.setAccessible(true);
//		Object[] param= {};
//		/*	Object[][] args = { {Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-1)},
//				{Integer.valueOf(-421)},
//				{Integer.valueOf(0)}};
//int[] resultats = {1,2,3, 4, 5, 10, 30, 60, 421, 0, 0, 0};*/
//		//	for (int i=0; i<args.length; i++) {
//		Object pt1=null;
//		int res=0;
//		List<Integer> l = null;
//		try {
//			pt1 = (const0.newInstance(param));//args[i]));
//			res = (int)(fieldValeur.get(pt1));
//			if (res!=0) {
//				System.out.println("   Aie... apres c = new CompteurHistorise() c."+fieldValeur.getName()+" a pour valeur "+res+" au lieu de 0.\n");
//				return 0;
//			}
//			l = (List<Integer>)fieldHistorique.get(pt1);
//			if (l==null) {
//				System.out.println("   Aie... apres c = new CompteurHistorise() c."+fieldHistorique.getName()+" a pour valeur null.\n");
//				return 0;
//			}
//			if (l.size()!=1) {
//				System.out.println("   Aie... apres c = new CompteurHistorise() c."+fieldHistorique.getName()+".size() vaut "+l.size()+" au lieu de 1 (l'historique doit contenir 0, la valeur initiale).\n");
//				return 0;
//			}
//			if (l.get(0)!=0) {
//				System.out.println("   Aie... apres c = new CompteurHistorise() c."+fieldHistorique.getName()+".get(0) vaut "+l.get(0)+" au lieu de 0 (l'historique doit contenir la valeur initiale).\n");
//				return 0;
//			}
//		} catch (Exception e) {
//			if (e instanceof InvocationTargetException) {
//				e.getCause().printStackTrace();
//			} else {
//				e.printStackTrace();
//			}
//			return 0;
//		}
//		//	}
//		String[] argss={};
//		String co = Reflexion.constructeurNomFic("src"+File.separator+"s05"+File.separator+"compteurs"+File.separator+"CompteurHistorise.java", "CompteurHistorise", argss);
//		co=Reflexion.sansEspacesAvantParentheses(co);
//		//System.out.println(">>>"+co+"<<<");
//		if (!co.contains("this(") && !co.contains("super(")) {
//			System.out.println("   Aie... Votre constructeur CompteurHistorise() doit operer PAR CHAINAGE");
//			return 50;
//		}
//
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test16CompteurHistoriseMethodesRedefinies() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurHistorise= Reflexion.getClass("s05.compteurs.CompteurHistorise");
//		if (cCompteurHistorise==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurHistorise dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurHistorise, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurHistorise n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null, fieldHistorique=null,  fieldOther=null;
//		Field[] tf = cCompteurHistorise.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(List.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldHistorique==null) {
//					fieldHistorique=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldHistorique==null) {
//			System.out.println("   Aie... CompteurHistorise doit avoir une variable d'instance de type liste d'entiers afin de memoriser l'historique des valeurs prises par le compteur");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorique dispose de la variable "+fieldOther.getName()+". La seule variable d'instance declaree dans CompteurHistorise devrait etre l'historique");
//			return 0;
//		}
//
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurHistorise alors que cette classe ne devrait declarer que l'historique pour variable d'instance (en plus de celle heritee)");
//			return 0;
//		}
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurHistorise n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorise dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurHistorise.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurHistorise.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurHistorise(int) ni le constructeur CompteurHistorise(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};
//		Class[] aro = {Object.class};
//		Method mDec=null, mInc=null, mEquals=null, mToString=null, mGetValeur=null;
//		try {
//			mDec = cCompteurHistorise.getDeclaredMethod("dec", ar);
//		} catch (NoSuchMethodException e1) {
//			//			e1.printStackTrace();
//		} catch (SecurityException e1) {
//			//			e1.printStackTrace();
//		}
//		try {
//			mInc = cCompteurHistorise.getDeclaredMethod("inc", ar);
//		} catch (Exception e1) {
//		} 
//		try {
//			mToString = cCompteurHistorise.getDeclaredMethod("toString", ar);
//		} catch (Exception e1) {
//		} 
//		try {
//			mGetValeur = cCompteurHistorise.getDeclaredMethod("getValeur", ar);
//		} catch (Exception e1) {
//		} 
//		try {
//			mEquals = cCompteurHistorise.getDeclaredMethod("equals", aro);
//		} catch (Exception e1) {
//		} 
//		if (mDec==null||mInc==null) {
//			System.out.println("   Aie... vous ne redefinissez pas une methode qui devrait l'etre");
//			return 0;
//		}
//
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		fieldValeur.setAccessible(true);
//		fieldHistorique.setAccessible(true);
//		Object[][] args = { 
//				{Integer.valueOf(1)},
//				{Integer.valueOf(2)},
//				{Integer.valueOf(3)},
//				{Integer.valueOf(4)},
//				{Integer.valueOf(5)},
//				{Integer.valueOf(10)},
//				{Integer.valueOf(30)},
//				{Integer.valueOf(60)},
//				{Integer.valueOf(421)},
//				{Integer.valueOf(-2)}};
//		Integer[][] resultats= {{1, 0, 1, 2, 3},
//				{2, 1, 2, 3, 4},
//				{3, 2, 3, 4, 5},
//				{4, 3, 4, 5, 6},
//				{5, 4, 5, 6, 7},
//				{10, 9, 10, 11, 12},
//				{30, 29, 30, 31, 32},
//				{60, 59, 60, 61, 62},
//				{421, 420, 421, 422, 423},
//				{-2, -3, -2, -1, 0}};
//		List<List<Integer>> lResultats=new ArrayList<List<Integer>>();
//		for (Integer[] t : resultats) {
//			lResultats.add(Arrays.asList(t));
//		}
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		List<Integer> l;
//		for (int i=0; i<args.length; i++) {
//			Object pt1=null;
//			int res=0;
//			l=null;
//			try {
//				param[0]=args[i][0];
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				fieldValeur.set(pt1,  args[i][0]);
//				List<Integer> init = new ArrayList<Integer>();
//				init.add((Integer)args[i][0]);
//				fieldHistorique.set(pt1,  init);
//				//res = (int)(
//				mDec.invoke(pt1, paramb);
//				mInc.invoke(pt1, paramb);
//				mInc.invoke(pt1, paramb);
//				mInc.invoke(pt1, paramb);
//				res = (int)fieldValeur.get(pt1);
//				if (res!=resultats[i][4]) {
//					System.out.println("   Aie... sur un CompteurHistorise ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" apres un appel a dec(), puis 3 appels a inc() c."+fieldValeur.getName()+" vaut "+res+" au lieu de "+resultats[i][4]+".\n");
//					return 0;
//				}
//				l = (List<Integer>)fieldHistorique.get(pt1);
//				if (l==null || !l.equals(lResultats.get(i))) {
//					System.out.println("   Aie... sur un CompteurHistorise ayant c."+fieldValeur.getName()+"=="+(int)args[i][0]+" apres un appel a dec(), puis 3 appels a inc() c."+fieldHistorique.getName()+" vaut "+l+" au lieu de "+lResultats.get(i)+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		if (mToString!=null||mGetValeur!=null||mEquals!=null) {
//			System.out.println("   Aie... vous redefinissez une/des methode(s) qui pourraient ne pas etre redefinies");
//			return 75;
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test17CompteurHistoriseGetMin() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurHistorise= Reflexion.getClass("s05.compteurs.CompteurHistorise");
//		if (cCompteurHistorise==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurHistorise dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurHistorise, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurHistorise n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null, fieldHistorique=null,  fieldOther=null;
//		Field[] tf = cCompteurHistorise.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(List.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldHistorique==null) {
//					fieldHistorique=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldHistorique==null) {
//			System.out.println("   Aie... CompteurHistorise doit avoir une variable d'instance de type liste d'entiers afin de memoriser l'historique des valeurs prises par le compteur");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorique dispose de la variable "+fieldOther.getName()+". La seule variable d'instance declaree dans CompteurHistorise devrait etre l'historique");
//			return 0;
//		}
//
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurHistorise alors que cette classe ne devrait declarer que l'historique pour variable d'instance (en plus de celle heritee)");
//			return 0;
//		}/*
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurHistorise n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}*/
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorise dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurHistorise.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurHistorise.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurHistorise(int) ni le constructeur CompteurHistorise(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};
//		Method mGetMin=null;
//		try {
//			mGetMin = cCompteurHistorise.getDeclaredMethod("getMin", ar);
//		} catch (NoSuchMethodException e1) {
//			e1.printStackTrace();
//			mGetMin=null;
//		} catch (SecurityException e1) {
//			e1.printStackTrace();
//			mGetMin=null;
//		}
//		if (mGetMin==null) {
//			System.out.println("   Aie... je ne trouve pas la methode getMin() dans la classe CompteurHistorise.");
//			return 0;
//		}
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		if (fieldValeur!=null) fieldValeur.setAccessible(true);
//		fieldHistorique.setAccessible(true);
//		Integer[][] historiques= {{1, 0, 1, 2, 3, 2, 1, 0, -1, -2, -1, 0},
//				{2, 3, 4, 5, 6},
//				{6, 5, 4, 3, 2},
//				{-1, 0, 1, 2, 3},
//				{3, 2, 1, 0, -1},
//				{0, -1, 0, 1, 0},
//				{-1, -2, -3, -2, -1},
//				{-50, -51, -52, -53, -52},
//				{500, 499, 498, 497, 498},
//				{-300, -301, -302, -303, -304, -305},
//				{Integer.MIN_VALUE+1,Integer.MIN_VALUE, Integer.MIN_VALUE+1}};
//		List<List<Integer>> lHistoriques=new ArrayList<List<Integer>>();
//		List<List<Integer>> lHistoriquesCopie=new ArrayList<List<Integer>>();
//		for (Integer[] t : historiques) {
//			lHistoriques.add(new ArrayList<Integer>(Arrays.asList(t)));
//			lHistoriquesCopie.add(new ArrayList<Integer>(Arrays.asList(t)));
//		}
//		int[] resultats= {-2, 2, 2, -1, -1, -1, -3, -53, 497, -305,Integer.MIN_VALUE};
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		List<Integer> l;
//		for (int i=0; i<historiques.length; i++) {
//			Object pt1=null;
//			int res=0;
//			l=null;
//			try {
//				param[0]=historiques[i][historiques[i].length-1];
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				if (fieldValeur!=null) fieldValeur.set(pt1,  lHistoriques.get(i).get(lHistoriques.get(i).size()-1));
//				List<Integer> init = new ArrayList<Integer>();
//				//init.add((Integer)args[i][0]);
//				fieldHistorique.set(pt1,  lHistoriques.get(i));
//				res = (int)(mGetMin.invoke(pt1, paramb));
//				if (res!=resultats[i]) {
//					System.out.println("   Aie... sur un CompteurHistorise ayant c."+fieldHistorique.getName()+"=="+lHistoriquesCopie.get(i)+" getMin() retourne "+res+" au lieu de "+resultats[i]+".\n");
//					return 0;
//				}
//				l = (List<Integer>)fieldHistorique.get(pt1);
//				if (l==null || !l.equals(lHistoriquesCopie.get(i))) {
//					System.out.println("   Aie... la methode getMin() ne doit pas modifier l'historique. Apres un appel a getMin() sur un compteurHistorise ayant pour historique "+lHistoriquesCopie.get(i)+" l'historique est devenu "+l+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test18CompteurHistoriseGetNbInc() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurHistorise= Reflexion.getClass("s05.compteurs.CompteurHistorise");
//		if (cCompteurHistorise==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurHistorise dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurHistorise, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurHistorise n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null, fieldHistorique=null,  fieldOther=null;
//		Field[] tf = cCompteurHistorise.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(List.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldHistorique==null) {
//					fieldHistorique=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldHistorique==null) {
//			System.out.println("   Aie... CompteurHistorise doit avoir une variable d'instance de type liste d'entiers afin de memoriser l'historique des valeurs prises par le compteur");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorique dispose de la variable "+fieldOther.getName()+". La seule variable d'instance declaree dans CompteurHistorise devrait etre l'historique");
//			return 0;
//		}
//
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurHistorise alors que cette classe ne devrait declarer que l'historique pour variable d'instance (en plus de celle heritee)");
//			return 0;
//		}/*
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurHistorise n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}*/
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorise dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurHistorise.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurHistorise.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurHistorise(int) ni le constructeur CompteurHistorise(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};
//		Method mGetNbInc=null;
//		try {
//			mGetNbInc = cCompteurHistorise.getDeclaredMethod("getNbInc", ar);
//		} catch (NoSuchMethodException e1) {
//			e1.printStackTrace();
//			mGetNbInc=null;
//		} catch (SecurityException e1) {
//			e1.printStackTrace();
//			mGetNbInc=null;
//		}
//		if (mGetNbInc==null) {
//			System.out.println("   Aie... je ne trouve pas la methode getNbInc() dans la classe CompteurHistorise.");
//			return 0;
//		}
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		if (fieldValeur!=null) fieldValeur.setAccessible(true);
//		fieldHistorique.setAccessible(true);
//		Integer[][] historiques= {{1, 0, 1, 2, 3, 2, 1, 0, -1, -2, -1, 0},
//				{2, 3, 4, 5, 6},
//				{6, 5, 4, 3, 2},
//				{-1, 0, 1, 2, 3},
//				{3, 2, 1, 0, -1},
//				{0, -1, 0, 1, 0},
//				{-1, -2, -3, -2, -1},
//				{-50, -51, -52, -53, -52},
//				{500, 499, 498, 497, 498},
//				{-300, -301, -302, -303, -304, -305},
//				{Integer.MIN_VALUE+1,Integer.MIN_VALUE, Integer.MIN_VALUE+1}, 
//				{-2, -1, 0, 1, 2, 3, 4, 5, 4, 3, 2, 1, 2, 3, 2, 1,2}};
//		List<List<Integer>> lHistoriques=new ArrayList<List<Integer>>();
//		List<List<Integer>> lHistoriquesCopie=new ArrayList<List<Integer>>();
//		for (Integer[] t : historiques) {
//			lHistoriques.add(new ArrayList<Integer>(Arrays.asList(t)));
//			lHistoriquesCopie.add(new ArrayList<Integer>(Arrays.asList(t)));
//		}
//		int[] resultats= {5, 4, 0, 4, 0, 2, 2, 1, 1, 0, 1, 10};
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		List<Integer> l;
//		for (int i=0; i<historiques.length; i++) {
//			Object pt1=null;
//			int res=0;
//			l=null;
//			try {
//				param[0]=historiques[i][historiques[i].length-1];
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				if (fieldValeur!=null) fieldValeur.set(pt1,  lHistoriques.get(i).get(lHistoriques.get(i).size()-1));
//				List<Integer> init = new ArrayList<Integer>();
//				//init.add((Integer)args[i][0]);
//				fieldHistorique.set(pt1,  lHistoriques.get(i));
//				res = (int)(mGetNbInc.invoke(pt1, paramb));
//				if (res!=resultats[i]) {
//					System.out.println("   Aie... sur un CompteurHistorise ayant c."+fieldHistorique.getName()+"=="+lHistoriquesCopie.get(i)+" getNbInc() retourne "+res+" au lieu de "+resultats[i]+".\n");
//					return 0;
//				}
//				l = (List<Integer>)fieldHistorique.get(pt1);
//				if (l==null || !l.equals(lHistoriquesCopie.get(i))) {
//					System.out.println("   Aie... la methode getNbInc() ne doit pas modifier l'historique. Apres un appel a getNbInc() sur un compteurHistorise ayant pour historique "+lHistoriquesCopie.get(i)+" l'historique est devenu "+l+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes", "unchecked" })
//	public static int test19CompteurHistoriseGetMaximaLocaux() {
//		Class cICompteur = Reflexion.getClass("s05.compteurs.ICompteur");
//		if (cICompteur==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface ICompteur dans le package compteurs");
//			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
//			return 0;
//		}	
//		Class cCompteurNonBorne= Reflexion.getClass("s05.compteurs.CompteurNonBorne");
//		if (cCompteurNonBorne==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurNonBorne dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		Class cCompteurHistorise= Reflexion.getClass("s05.compteurs.CompteurHistorise");
//		if (cCompteurHistorise==null) {
//			System.out.println("   Aie... je ne trouve pas la classe CompteurHistorise dans le package compteurs. Impossible de tester");
//			return 0;
//		}
//		if (!Reflexion.extendsClass(cCompteurHistorise, cCompteurNonBorne)) {
//			System.out.println("   Aie... la classe CompteurHistorise n'herite pas de/ne specialise pas CompteurNonBorne");
//			return 0;
//		}
//
//		Field fieldValeur=null, fieldHistorique=null,  fieldOther=null;
//		Field[] tf = cCompteurHistorise.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(List.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldHistorique==null) {
//					fieldHistorique=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldHistorique==null) {
//			System.out.println("   Aie... CompteurHistorise doit avoir une variable d'instance de type liste d'entiers afin de memoriser l'historique des valeurs prises par le compteur");
//			return 0;
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorique dispose de la variable "+fieldOther.getName()+". La seule variable d'instance declaree dans CompteurHistorise devrait etre l'historique");
//			return 0;
//		}
//
//		Field[] tfnb= cCompteurNonBorne.getDeclaredFields();
//		for (Field f : tfnb) {
//			//System.out.println(f.getName());
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldValeur==null) {
//					fieldValeur=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (nbv!=1) {
//			System.out.println("   Aie... Vous avez defini "+nbv+" variables d'instances dans CompteurHistorise alors que cette classe ne devrait declarer que l'historique pour variable d'instance (en plus de celle heritee)");
//			return 0;
//		}/*
//		if (fieldValeur==null) {
//			System.out.println("   Aie... CompteurHistorise n'herite pas d'une variable permettant de memorise sa valeur : impossible de poursuivre les tests");
//			return 0;
//		}*/
//		if (fieldOther!=null) {
//			System.out.println("   Aie... CompteurHistorise dispose de la variable "+fieldOther.getName()+". La seule variable d'instance heritee de CompteurNonBorne devrait etre la variable entiere memorisant la valeur du compteur");
//			return 0;
//		}
//		Class[] arg2 = { int.class };
//		Class[] arg2b = {};// int.class };
//		Constructor const0=null;
//		Constructor const0b=null;
//		try {
//			const0 = cCompteurHistorise.getConstructor(arg2);//.getDeclaredConstructor(arg2);
//		} catch (NoSuchMethodException e) {
//			//e.printStackTrace();
//			const0=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			const0=null;
//		}
//		if (const0==null) {
//			try {
//				const0b = cCompteurHistorise.getConstructor(arg2b);//.getDeclaredConstructor(arg2b);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				const0b=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				const0b=null;
//			}
//			if (const0b==null) {
//
//				System.out.println("   Aie... je ne trouve ni le constructeur CompteurHistorise(int) ni le constructeur CompteurHistorise(). Impossible de tester");
//				return 0;
//			}
//		}
//		/*if (Modifier.isPrivate(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre private");
//			return 0;
//		}
//		if (Modifier.isProtected(const0.getModifiers())) {
//			System.out.println("   Aie... votre constructeur CompteurNonBorne() ne devrait pas etre protected");
//			return 0;
//		}*/
//		Class[] ar = {};
//		Method mGetLax=null;
//		try {
//			mGetLax = cCompteurHistorise.getDeclaredMethod("getMaximaLocaux", ar);
//		} catch (NoSuchMethodException e1) {
//			e1.printStackTrace();
//			mGetLax=null;
//		} catch (SecurityException e1) {
//			e1.printStackTrace();
//			mGetLax=null;
//		}
//		if (mGetLax==null) {
//			System.out.println("   Aie... je ne trouve pas la methode getMaximaLocaux() dans la classe CompteurHistorise.");
//			return 0;
//		}
//		if (const0!=null) const0.setAccessible(true);
//		if (const0b!=null) const0b.setAccessible(true);
//		if (fieldValeur!=null) fieldValeur.setAccessible(true);
//		fieldHistorique.setAccessible(true);
//		Integer[][] historiques= {{1, 0, 1, 2, 3, 2, 1, 0, -1, -2, -1, 0},
//				{2, 3, 4, 5, 6},
//				{6, 5, 4, 3, 2},
//				{-1, 0, 1, 2, 3},
//				{3, 2, 1, 0, -1},
//				{0, -1, 0, 1, 0},
//				{-1, -2, -3, -2, -1},
//				{-50, -51, -52, -53, -52},
//				{500, 499, 498, 497, 498},
//				{-300, -301, -302, -303, -304, -305},
//				{Integer.MIN_VALUE+1,Integer.MIN_VALUE, Integer.MIN_VALUE+1}, 
//				{-2, -1, 0, 1, 2, 3, 4, 5, 4, 3, 2, 1, 2, 3, 2, 1,2}};
//		List<List<Integer>> lHistoriques=new ArrayList<List<Integer>>();
//		List<List<Integer>> lHistoriquesCopie=new ArrayList<List<Integer>>();
//		for (Integer[] t : historiques) {
//			lHistoriques.add(new ArrayList<Integer>(Arrays.asList(t)));
//			lHistoriquesCopie.add(new ArrayList<Integer>(Arrays.asList(t)));
//		}
//		Integer[][] resultats= {{1,3,0},
//				{6},
//				{6},
//				{3},
//				{3},
//				{0, 1},
//				{-1, -1},
//				{-50,-52},
//				{500, 498},
//				{-300}, 
//				{Integer.MIN_VALUE+1,Integer.MIN_VALUE+1},
//				{5, 3, 2}};
//		List<List<Integer>> lResultats=new ArrayList<List<Integer>>();
//		for (Integer[] t : resultats) {
//			lResultats.add(new ArrayList<Integer>(Arrays.asList(t)));
//		}
//		Object[] param = {Integer.valueOf(0)};
//		Object[] paramb = {};
//		List<Integer> l;
//		for (int i=0; i<historiques.length; i++) {
//			Object pt1=null;
//			List<Integer> res=null;
//			l=null;
//			try {
//				param[0]=historiques[i][historiques[i].length-1];
//				pt1 = const0!=null ? (const0.newInstance(param)):(const0b.newInstance(paramb));//args[i]));
//				if (fieldValeur!=null) fieldValeur.set(pt1,  lHistoriques.get(i).get(lHistoriques.get(i).size()-1));
//				List<Integer> init = new ArrayList<Integer>();
//				//init.add((Integer)args[i][0]);
//				fieldHistorique.set(pt1,  lHistoriques.get(i));
//				res = (List<Integer>)(mGetLax.invoke(pt1, paramb));
//				if (!Outils.egaux(res, lResultats.get(i))) {
//					System.out.println("   Aie... sur un CompteurHistorise ayant c."+fieldHistorique.getName()+"=="+lHistoriquesCopie.get(i)+" getMaximaLocaux() retourne "+res+" au lieu de "+lResultats.get(i)+".\n");
//					return 0;
//				}
//				l = (List<Integer>)fieldHistorique.get(pt1);
//				if (l==null || !l.equals(lHistoriquesCopie.get(i))) {
//					System.out.println("   Aie... la methode getMaximaLocaux() ne doit pas modifier l'historique. Apres un appel a getMaximaLocaux() sur un compteurHistorise ayant pour historique "+lHistoriquesCopie.get(i)+" l'historique est devenu "+l+".\n");
//					return 0;
//				}
//			} catch (Exception e) {
//				if (e instanceof InvocationTargetException) {
//					e.getCause().printStackTrace();
//				} else {
//					e.printStackTrace();
//				}
//				return 0;
//			}
//		}
//		System.out.println(" OK, votre implementation passe le test.");
//		return 100;
//	}
//
//
//
//	@SuppressWarnings({ "rawtypes" })
//	public static int test20MediathequeIMedia() {
//		double estInterface=0.0;
//		double getTitre=0.0;
//		//double getReference=0.0;
//		double autresMethodes=0.0;
//		Method mGetTitre=null;
//		Method mGetReference=null;
//		Method mAutre=null;
//
//		Class cIMedia = Reflexion.getClass("s05.mediatheque.IMedia");
//		if (cIMedia==null) {
//			System.out.println("   Aie... je ne trouve pas l'interface IMedia dans le package mediatheque");
//			return 0;
//		}
//		if (!cIMedia.isInterface()) {
//			System.out.println("   Aie... IMedia doit etre une interface");
//		} else {
//			estInterface=1.0;
//		}
//		for (Method m : cIMedia.getDeclaredMethods()) {
//			if (mGetTitre==null && m.getName().equals("getTitre")) {
//				mGetTitre=m;
//				getTitre=0.5;
//				if (m.getParameterTypes().length==0) {
//					getTitre+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getTitre() ne doit pas avoir de parametres");
//				}
//				if (m.getReturnType().equals(String.class)) {
//					getTitre+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getTitre() doit retourne une String");
//				}
//				/*} else if (mGetReference==null && m.getName().equals("getReference")) {
//				mGetReference=m;
//				getReference=0.5;
//				if (m.getParameterTypes().length==0) {
//					getReference+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getReference() ne doit pas avoir de parametres");
//				}
//				if (m.getReturnType().equals(int.class)) {
//					getReference+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getReference() doit retourne un int");
//				}*/
//			} else {
//				mAutre=m;
//				System.out.println("   Aie... le diagramme ne precise pas la methode "+m.getName()+" pour l'interface IMedia");
//			}
//		}
//		if (mAutre==null) {
//			autresMethodes=1.0;
//		}
//		return 25 //IMedia existe
//				+(int)(estInterface*25)
//				+(int)(getTitre*25)
//				//+(int)(getReference*20)
//				+(int)( (autresMethodes)*25);
//	}
//
//
//	@SuppressWarnings({ "rawtypes" })
//	public static int test21MediathequeLivre() {
//		double estClasse=0.0;
//		double implemente=0.0;
//		double titre=0.0;
//		//double reference=0.0;
//		double getTitre=0.0;
//		//double getReference=0.0;
//		double autresMethodes=0.0;
//		double construct=0.0;
//		double fonctConst=0.0;
//		double fonctGetTitre=0.0;
//		double autreFields=1.0;
//
//		Method mGetTitre=null;
//		Method mGetReference=null;
//		Method mAutre=null;
//
//		Class cLivre = Reflexion.getClass("s05.mediatheque.Livre");
//		if (cLivre==null) {
//			System.out.println("   Aie... je ne trouve pas la classe Livre dans le package mediatheque");
//			return 0;
//		}
//		Class cIMedia = Reflexion.getClass("s05.mediatheque.IMedia");
//		if (cIMedia!=null && cIMedia.isInterface() && Reflexion.implementsInterface(cLivre, cIMedia)) {
//			implemente=1.0;
//		} else {
//			System.out.println("   Aie... Livre n'implemente pas l'interface IMedia");
//		}
//		if (!cLivre.isInterface()) {
//			estClasse=1.0;
//		}
//
//		Field fieldTitre=null,// fieldReference=null, 
//				fieldOther=null;
//		Field[] tf = cLivre.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			/*if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldReference==null) {
//					fieldReference=f;
//				} else {
//					fieldOther=f;
//				}
//			} else */
//			if ( f.getType().equals(String.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldTitre==null) {
//					fieldTitre=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		/*if (fieldReference==null) {
//			System.out.println("   Aie... Livre doit avoir une variable d'instance de type int pour memoriser la reference");
//		} else {
//			reference=0.5;
//			if (Modifier.isPrivate(fieldReference.getModifiers())) {
//				reference+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}*/
//		if (fieldTitre==null) {
//			System.out.println("   Aie... Livre doit avoir une variable d'instance de type String pour memoriser le titre");
//		} else {
//			titre=0.5;
//			if (Modifier.isPrivate(fieldTitre.getModifiers())) {
//				titre+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Livre dispose de la variable "+fieldOther.getName()+". Elle ne devrait avoir que la variable d'instance titre");
//			autreFields=0.0;
//		}
//
//		for (Method m : cLivre.getDeclaredMethods()) {
//			if (mGetTitre==null && m.getName().equals("getTitre")) {
//				mGetTitre=m;
//				getTitre=0.5;
//				if (m.getParameterTypes().length==0) {
//					getTitre+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getTitre() ne doit pas avoir de parametres");
//				}
//				if (m.getReturnType().equals(String.class)) {
//					getTitre+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getTitre() doit retourne une String");
//				}
//				/*} else if (mGetReference==null && m.getName().equals("getReference")) {
//				mGetReference=m;
//				getReference=0.5;
//				if (m.getParameterTypes().length==0) {
//					getReference+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getReference() ne doit pas avoir de parametres");
//				}
//				if (m.getReturnType().equals(int.class)) {
//					getReference+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getReference() doit retourne un int");
//				}*/
//			} else {
//				mAutre=m;
//				System.out.println("   Aie... le diagramme ne precise pas la methode "+m.getName()+" pour la classe Livre");
//			}
//		}
//		if (mAutre==null) {
//			autresMethodes=1.0;
//		}
//		Class[] argConst = { String.class };
//		Constructor c2=null;
//		try {
//			c2 = cLivre.getDeclaredConstructor(argConst);
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			c2=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			c2=null;
//		}
//		if (c2==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur Livre(String).");
//		} else {
//			construct=1.0;
//			if (fieldTitre!=null) fieldTitre.setAccessible(true);
//			Object pt1=null;
//			Object[] args = {"aaa"};
//			String resTitre="";
//			fonctConst=1.0;
//			try {
//				pt1 = (c2.newInstance(args));
//				resTitre=(String)fieldTitre.get(pt1);
//				//resCote = (int)(mGetCote.invoke(pt1,  ar));
//				if (!resTitre.equals("aaa")) {
//					fonctConst=0.0;
//				} else {
//					args[0]="autant";
//					pt1 = (c2.newInstance(args));
//					resTitre=(String)fieldTitre.get(pt1);
//					//resCote = (int)(mGetCote.invoke(pt1,  ar));
//					if (!resTitre.equals("autant")) {
//						fonctConst=0.0;
//					} else {
//						args[0]="pony";
//						pt1 = (c2.newInstance(args));
//						resTitre=(String)fieldTitre.get(pt1);
//						//resCote = (int)(mGetCote.invoke(pt1,  ar));
//						if (!resTitre.equals("pony")) {
//							fonctConst=0.0;
//						} else {
//
//						}
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctConst=0.0;
//			}
//
//		}
//		Object pt1=null;
//		Object[] args = {"aaa"};
//		Object[] ar= {};
//		String resTitre="";
//		fonctGetTitre=1.0;
//
//		if (fieldTitre!=null) {
//			String resuTitre;
//			try {
//				pt1 = (c2.newInstance(args));
//				fieldTitre.set(pt1, args[0]);
//				resuTitre = (String)(mGetTitre.invoke(pt1,  ar));
//				if (resuTitre==null || !resuTitre.equals("aaa")) {
//					fonctGetTitre=0.0;
//				} else {
//					pt1 = (c2.newInstance(args));
//					fieldTitre.set(pt1,"toto");
//					resuTitre = (String)(mGetTitre.invoke(pt1,  ar));
//					if (resuTitre==null || !resuTitre.equals("toto")) {
//						fonctGetTitre=0.0;
//					} else {
//						pt1 = (c2.newInstance(args));
//						fieldTitre.set(pt1, "tutu");
//						resuTitre = (String)(mGetTitre.invoke(pt1,  ar));
//						if (resuTitre==null || !resuTitre.equals("tutu")) {
//							fonctGetTitre=0.0;
//						} else {
//
//						}
//
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//			}
//		}
//		//System.out.println(titre+" - "+estClasse+" - "+autreFields+" - "+getTitre+" - "+fonctGetTitre+" - "+autresMethodes+" - "+construct+" - "+fonctConst);
//		return 20 //IMedia existe
//				+(int)(titre*10) // la variable d'instance existe et est private
//				+(int)(estClasse*10)
//				+(int)(autreFields*10) // il n'y a pas d'autres variables d'instance definies
//				+(int)(getTitre*10)
//				+(int)(fonctGetTitre*10)// getTitre fonctionne
//				+(int)( (autresMethodes)*10) // il n'y a pas d'autres methodes
//				+(int)(construct*10) // le constructeur est la et avec bons parametres
//				+(int)(fonctConst*10);
//	}
//
//
//
//
//	@SuppressWarnings({ "rawtypes" })
//	public static int test22MediathequeLivreAudio() {
//		double estClasse=0.0;
//		double extend=0.0;
//		double titre=0.0;
//		double duree=0.0;
//		//double getTitre=0.0;
//		double getDuree=0.0;
//		double autresMethodes=0.0;
//		double construct=0.0;
//		double fonctConst=0.0;
//		double fonctGetDuree=0.0;
//		double other=0.0;
//		Method mGetDuree=null;
//		//	Method mGetReference=null;
//		Method mAutre=null;
//
//		Class cLivre = Reflexion.getClass("s05.mediatheque.Livre");
//		if (cLivre==null) {
//			System.out.println("   Aie... je ne trouve pas la classe Livre dans le package mediatheque");
//			//return 0;
//		}
//		Class cLivreAudio = Reflexion.getClass("s05.mediatheque.LivreAudio");
//		if (cLivreAudio==null) {
//			System.out.println("   Aie... je ne trouve pas la classe LivreAudio dans le package mediatheque");
//			return 0;
//		}
//		Class cIMedia = Reflexion.getClass("s05.mediatheque.IMedia");
//		if (cLivre!=null && !cLivre.isInterface() && !cLivreAudio.isInterface()&& Reflexion.extendsClass(cLivreAudio, cLivre)) {
//			extend=1.0;
//		} else {
//			System.out.println("   Aie... LivreAudio n'herite pas de Livre");
//		}
//		if (!cLivreAudio.isInterface()) {
//			estClasse=1.0;
//		}
//
//		Field fieldTitre=null,fieldDuree=null, 
//				fieldOther=null;
//		Field[] tf = cLivreAudio.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldDuree==null) {
//					fieldDuree=f;
//				} else {
//					fieldOther=f;
//				}
//				/*	} else 
//				if ( f.getType().equals(String.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldTitre==null) {
//					fieldTitre=f;
//				} else {
//					fieldOther=f;
//				}*/
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		tf = cLivre.getDeclaredFields();
//		nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			/*	if ( f.getType().equals(int.class) && !Modifier.isStatic(f.getModifiers())) {
//					if (fieldDuree==null) {
//						fieldDuree=f;
//					} else {
//						fieldOther=f;
//					}
//				} else */
//			if ( f.getType().equals(String.class) && !Modifier.isStatic(f.getModifiers())) {
//				if (fieldTitre==null) {
//					fieldTitre=f;
//				} /*else {
//						fieldOther=f;
//					}//*/
//			} /*else if (!Modifier.isStatic(f.getModifiers())) {
//					fieldOther=f;
//				}*/
//		}
//		if (fieldDuree==null) {
//			System.out.println("   Aie... LivreAudio doit avoir une variable d'instance de type int pour memoriser la duree");
//		} else {
//			duree=0.5;
//			if (Modifier.isPrivate(fieldDuree.getModifiers())) {
//				duree+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}
//
//		/*	if (fieldTitre==null) {
//			System.out.println("   Aie... Livre doit avoir une variable d'instance de type String pour memoriser le titre");
//		} else {
//			titre=0.5;
//			if (Modifier.isPrivate(fieldTitre.getModifiers())) {
//				titre+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}*/
//		if (fieldOther!=null) {
//			System.out.println("   Aie... LivreAudio dispose de la variable "+fieldOther.getName()+". Elle ne devrait avoir que la variable d'instance duree en plus de celle heritee");
//			other= 0.0;
//		} else {
//			other = 1.0;
//		}
//		if (fieldTitre!=null) fieldTitre.setAccessible(true);
//		if (fieldDuree!=null) fieldDuree.setAccessible(true);
//
//		for (Method m : cLivreAudio.getDeclaredMethods()) {
//			//System.out.println("declared : "+m.getName());
//			if (mGetDuree==null && m.getName().equals("getDuree")) {
//				mGetDuree=m;
//				getDuree=0.5;
//				if (m.getParameterTypes().length==0) {
//					getDuree+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getDuree() ne doit pas avoir de parametres");
//				}
//				if (m.getReturnType().equals(int.class)) {
//					getDuree+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getDuree() doit retourner un int");
//				}
//			} /*else if (mGetReference==null && m.getName().equals("getReference")) {
//				mGetReference=m;
//				getDuree=0.5;
//				if (m.getParameterTypes().length==0) {
//					getDuree+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getReference() ne doit pas avoir de parametres");
//				}
//				if (m.getReturnType().equals(int.class)) {
//					getDuree+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getReference() doit retourne un int");
//				}
//			} //*/
//			else {
//				mAutre=m;
//				System.out.println("   Aie... le diagramme ne precise pas la methode "+m.getName()+" pour la classe LivreAudio");
//			}
//		}
//		if (mAutre==null) {
//			autresMethodes=1.0;
//		}
//		Class[] argConst = { String.class, int.class };
//		Constructor c2=null;
//		Class[] argConst0 = { };
//		Constructor c0=null;
//		try {
//			c2 = cLivreAudio.getDeclaredConstructor(argConst);
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			c2=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			c2=null;
//		}
//		if (c2==null) {
//			try {
//				c0 = cLivreAudio.getDeclaredConstructor(argConst0);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				c0=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				c0=null;
//			}	
//		}
//		if (c2==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur LivreAudio(String, int).");
//		} else {
//			construct=1.0;
//			if (fieldTitre!=null) fieldTitre.setAccessible(true);
//			Object pt1=null;
//			Object[] args = {"aaa", Integer.valueOf(120)};
//			String resTitre="";
//			int resDuree=0;
//			fonctConst=1.0;
//			try {
//				pt1 = (c2.newInstance(args));
//				if (fieldTitre!=null) resTitre=(String)fieldTitre.get(pt1);
//				if (fieldDuree!=null) resDuree=(int)fieldDuree.get(pt1);
//				//resCote = (int)(mGetCote.invoke(pt1,  ar));
//				if (!resTitre.equals("aaa")) {
//					System.out.println("   Aie... le constructeur de LivreAudio n'initialise pas convenablement le titre");
//					fonctConst=0.0;
//				} else if (resDuree!=120) {
//					System.out.println("   Aie... le constructeur de LivreAudio n'initialise pas convenablement la duree");
//					fonctConst=0.0;
//				} else {
//					args[0]="autant";
//					args[1]=Integer.valueOf(60);
//					pt1 = (c2.newInstance(args));
//					if (fieldTitre!=null) resTitre=(String)fieldTitre.get(pt1);
//					if (fieldDuree!=null) resDuree=(int)fieldDuree.get(pt1);
//					//resCote = (int)(mGetCote.invoke(pt1,  ar));
//					if (!resTitre.equals("autant")) {
//						System.out.println("   Aie... le constructeur de LivreAudio n'initialise pas convenablement le titre");
//						fonctConst=0.0;
//					} else if (resDuree!=60) {
//						System.out.println("   Aie... le constructeur de LivreAudio n'initialise pas convenablement la duree");
//						fonctConst=0.0;
//					} else{
//						args[0]="pony";
//						args[1]=Integer.valueOf(30);
//						pt1 = (c2.newInstance(args));
//						if (fieldTitre!=null) resTitre=(String)fieldTitre.get(pt1);
//						if (fieldDuree!=null) resDuree=(int)fieldDuree.get(pt1);
//						//resCote = (int)(mGetCote.invoke(pt1,  ar));
//						if (!resTitre.equals("pony")) {
//							System.out.println("   Aie... le constructeur de LivreAudio n'initialise pas convenablement le titre");
//							fonctConst=0.0;
//						} else 	if (resDuree!=30) {
//							System.out.println("   Aie... le constructeur de LivreAudio n'initialise pas convenablement la duree");
//							fonctConst=0.0;
//						}
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctConst=0.0;
//			}
//		}
//		Object pt1=null;
//		Object[] args = {"aaa", Integer.valueOf(120)};
//		Object[] ar= {};
//		String resTitre="";
//		fonctGetDuree=1.0;
//
//		if (fieldDuree==null || mGetDuree==null) {
//			fonctGetDuree=0.0;
//		} else {
//			fieldDuree.setAccessible(true);
//			int resuDuree;
//			try {
//				if (c2!=null) {
//					pt1 = (c2.newInstance(args));
//				} else {
//					pt1 = c0.newInstance(ar);
//				}
//				fieldDuree.set(pt1, 120);
//				resuDuree = (int)(mGetDuree.invoke(pt1,  ar));
//				if (resuDuree!=120) {
//					System.out.println("   Aie... getDuree() ne retourne pas la valeur de la variable duree");
//					fonctGetDuree=0.0;
//				} else {
//					if (c2!=null) {
//						pt1 = (c2.newInstance(args));
//					} else {
//						pt1 = c0.newInstance(ar);
//					}
//					fieldDuree.set(pt1,Integer.valueOf(60));
//					resuDuree = (int)(mGetDuree.invoke(pt1,  ar));
//					if (resuDuree!=60) {
//						System.out.println("   Aie... getDuree() ne retourne pas la valeur de la variable duree");
//						fonctGetDuree=0.0;
//					} else {
//						if (c2!=null) {
//							pt1 = (c2.newInstance(args));
//						} else {
//							pt1 = c0.newInstance(ar);
//						}
//						fieldDuree.set(pt1, Integer.valueOf(30));
//						resuDuree = (int)(mGetDuree.invoke(pt1,  ar));
//						if (resuDuree!=30) {
//							System.out.println("   Aie... getDuree() ne retourne pas la valeur de la variable duree");
//							fonctGetDuree=0.0;
//						} else {
//
//						}
//
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctGetDuree=0.0;
//			}
//		}
//
//		//System.out.println(estClasse+" - "+extend+" - "+construct+" - "+fonctConst+" - "+duree+" - "+getDuree+" - "+fonctGetDuree+" - "+autresMethodes);
//		return 15 //IMedia existe
//				+(int)(estClasse*5)
//				+(int)(extend*15)
//				+(int)(construct*5)
//				+(int)(fonctConst*15)
//				+(int)(fonctGetDuree*10)
//				+(int)(duree*10)
//				+(int)(getDuree*10)
//				+(int)(other*5)
//				+(int)( (autresMethodes)*10);
//	}
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes" })
//	public static int test23MediathequeEmprunt() {
//		double estClasse=0.0;
//		//double extend=0.0;
//		double emprunt=0.0;
//		double restitution=0.0;
//		double media=0.0;
//		double abonne=0.0;
//		double other=0.0;
//		double getMedia=0.0;
//		double getAbonne=0.0;
//		double getDateEmprunt=0.0;
//		double getDateRestitution=0.0;
//		double autresMethodes=0.0;
//
//		double construct=0.0;
//		double fonctConst=0.0;
//		double fonctGetMedia=0.0;
//		double fonctGetDateEmprunt=0.0;
//		double fonctGetDateRestitution=0.0;
//		double fonctGetAbonne=0.0;
//
//		Class cLivre = Reflexion.getClass("s05.mediatheque.Livre");
//		Class cAbonne = Reflexion.getClass("s05.mediatheque.Abonne");
//		//if (cAbonne==null) {
//		//	System.out.println("   Aie... je ne trouve pas la classe Abonne dans le package mediatheque");
//		//return 0;
//		//}
//		Class cEmprunt= Reflexion.getClass("s05.mediatheque.Emprunt");
//		if (cEmprunt==null) {
//			System.out.println("   Aie... je ne trouve pas la classe Emprunt dans le package mediatheque");
//			return 0;
//		}
//		Class cIMedia = Reflexion.getClass("s05.mediatheque.IMedia");
//		/*if (cAbonne!=null && cIMedia.isInterface() && !cEmprunt.isInterface()&& Reflexion.extendsClass(cEmprunt, cAbonne)) {
//			extend=1.0;
//		} else {
//			System.out.println("   Aie... LivreAudio n'herite pas de Livre");
//		}*/
//		if (!cEmprunt.isInterface()) {
//			estClasse=1.0;
//		}
//
//		Field fieldEmprunt=null,fieldRestitution=null, fieldMedia=null, fieldAbonne = null, 
//				fieldOther=null;
//		Field[] tf = cEmprunt.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( f.getType().equals(Date.class) && !Modifier.isStatic(f.getModifiers()) && !f.getName().contains("emp")) {
//				if (fieldRestitution==null) {
//					fieldRestitution=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if ( f.getType().equals(Date.class) && !Modifier.isStatic(f.getModifiers()) && f.getName().contains("emp")) {
//				if (fieldEmprunt==null) {
//					fieldEmprunt=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if ( cIMedia!=null && f.getType().equals(cIMedia) && !Modifier.isStatic(f.getModifiers())) {// && f.getName().contains("emp")) {
//				if (fieldMedia==null) {
//					fieldMedia=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if ( cAbonne!=null && f.getType().equals(cAbonne) && !Modifier.isStatic(f.getModifiers())) {// && f.getName().contains("emp")) {
//				if (fieldAbonne==null) {
//					fieldAbonne=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldRestitution==null) {
//			System.out.println("   Aie... Je ne trouve pas de variable d'instance permettant de memoriser la date de restitution");
//		} else {
//			restitution=0.5;
//			if (Modifier.isPrivate(fieldRestitution.getModifiers())) {
//				restitution+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}
//		if (fieldEmprunt==null) {
//			System.out.println("   Aie... Je ne trouve pas de variable d'instance permettant de memoriser la date d'emprunt");
//		} else {
//			emprunt=0.5;
//			if (Modifier.isPrivate(fieldEmprunt.getModifiers())) {
//				emprunt+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}
//		if (fieldMedia==null) {
//			System.out.println("   Aie... Je ne trouve pas de variable d'instance permettant de memoriser le media d'un emprunt");
//		} else {
//			media=0.5;
//			if (Modifier.isPrivate(fieldMedia.getModifiers())) {
//				media+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}
//		if (fieldAbonne==null) {
//			System.out.println("   Aie... Je ne trouve pas de variable d'instance permettant de memoriser l'abonne d'un emprunt");
//		} else {
//			abonne=0.5;
//			if (Modifier.isPrivate(fieldAbonne.getModifiers())) {
//				abonne+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}
//
//		/*	if (fieldTitre==null) {
//			System.out.println("   Aie... Livre doit avoir une variable d'instance de type String pour memoriser le titre");
//		} else {
//			titre=0.5;
//			if (Modifier.isPrivate(fieldTitre.getModifiers())) {
//				titre+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}*/
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Emprunt dispose de la variable "+fieldOther.getName()+". Elle ne devrait avoir que la variable d'instance duree en plus de celle heritee");
//			other=0.0;
//		} else {
//			if (abonne!=0.0 || emprunt!=0.0 || restitution!=0 || media!=0.0) {
//				other=1.0;
//			}
//		}
//		if (fieldEmprunt!=null) fieldEmprunt.setAccessible(true);
//		if (fieldRestitution!=null) fieldRestitution.setAccessible(true);
//		if (fieldMedia!=null) fieldMedia.setAccessible(true);
//		if (fieldAbonne!=null) fieldAbonne.setAccessible(true);
//
//		Method mGetDateEmprunt=null;
//		Method mGetDateRestitution=null;
//		Method mGetMedia=null;
//		Method mGetAbonne=null;
//		Method mAutre=null;
//
//		for (Method m : cEmprunt.getDeclaredMethods()) {
//			//System.out.println("declared : "+m.getName());
//			if (mGetDateEmprunt==null && m.getName().toLowerCase().equals("getdateemprunt")) {
//				mGetDateEmprunt=m;
//				getDateEmprunt=0.5;
//				if (m.getParameterTypes().length==0) {
//					getDateEmprunt+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getDateEmprunt() ne doit pas avoir de parametres");
//				}
//				if (m.getReturnType().equals(Date.class)) {
//					getDateEmprunt+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getDateEmprunt() doit retourner une Date");
//				}
//			} else if (mGetDateRestitution==null && m.getName().toLowerCase().equals("getdaterestitution")) {
//				mGetDateRestitution=m;
//				getDateRestitution=0.5;
//				if (m.getParameterTypes().length==0) {
//					getDateRestitution+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getDateRestitution() ne doit pas avoir de parametres");
//				}
//				if (m.getReturnType().equals(Date.class)) {
//					getDateRestitution+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getDateRestitution() doit retourner une Date");
//				}
//			} else if (mGetMedia==null && m.getName().toLowerCase().equals("getmedia")) {
//				mGetMedia=m;
//				getMedia=0.5;
//				if (m.getParameterTypes().length==0) {
//					getMedia+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getMedia() ne doit pas avoir de parametres");
//				}
//				if (cIMedia!=null && m.getReturnType().equals(cIMedia)) {
//					getMedia+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getMedia() doit retourner un IMedia");
//				}
//			} else if (mGetAbonne==null && m.getName().toLowerCase().equals("getabonne")) {
//				mGetAbonne=m;
//				getAbonne=0.5;
//				if (m.getParameterTypes().length==0) {
//					getAbonne+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getAbonne() ne doit pas avoir de parametres");
//				}
//				if (cAbonne!=null && m.getReturnType().equals(cAbonne)) {
//					getAbonne+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getAbonne() doit retourner un Abonne");
//				}
//			} 
//			else {
//				mAutre=m;
//				System.out.println("   Aie... le diagramme ne precise pas la methode "+m.getName()+" pour la classe Emprunt");
//			}
//		}
//		if (mAutre==null && (mGetAbonne!=null || mGetDateEmprunt!=null || mGetDateRestitution!=null || mGetMedia!=null)) {
//			autresMethodes=1.0;
//		}
//		Class[] argConst = { Date.class, Date.class, cIMedia, cAbonne };
//		Constructor c2=null;
//		Class[] argConst0 = { };
//		Constructor c0=null;
//		try {
//			if (cIMedia!=null && cAbonne!=null) {
//				c2 = cEmprunt.getDeclaredConstructor(argConst);
//			}
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			c2=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			c2=null;
//		}
//		if (c2==null) {
//			try {
//				c0 = cEmprunt.getDeclaredConstructor(argConst0);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				c0=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				c0=null;
//			}	
//		}
//		if (c2==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur Emprunt(Date, Date, IMedia, Abonne).");
//		} else {
//			construct=1.0;
//			if (fieldEmprunt!=null) fieldEmprunt.setAccessible(true);
//			Object pt1=null;
//			Class[] argl = {String.class};
//			try {
//				Constructor cl =  cLivre.getDeclaredConstructor(argl);
//				Object[] arl = {"toto"};
//
//				/*Date resDateE=null;
//			Date resDateR=null;
//			Abonne resAbo = null;
//			Object resLivre=null;*/
//				fonctConst=1.0;
//				//System.out.println("test const");
//				try {
//					Object livr = cl.newInstance(arl);
//					Abonne ab = new Abonne("titi", new Date(4,2,1903));
//					Date dateE=new Date(1,2,1903);
//					Date dateR=new Date(2,3,1903);
//					Object[] args = {dateE, dateR, livr, ab};
//
//					pt1 = (c2.newInstance(args));
//					//if (fieldEmprunt!=null) resTitre=(String)fieldEmprunt.get(pt1);
//					//if (fieldRestitution!=null) resDuree=(int)fieldRestitution.get(pt1);
//					//resCote = (int)(mGetCote.invoke(pt1,  ar));
//					if (!fieldEmprunt.get(pt1).equals(dateE)) {
//						System.out.println("   Aie... le constructeur de Emprunt n'initialise pas convenablement la date d'emprunt");
//						fonctConst=0.0;
//					} else if (!fieldRestitution.get(pt1).equals(dateR)) {
//						System.out.println("   Aie... le constructeur de Emprunt n'initialise pas convenablement la date de restitution");
//						fonctConst=0.0;
//					} else if (!fieldMedia.get(pt1).equals(livr)) {
//						System.out.println("   Aie... le constructeur de Emprunt n'initialise pas convenablement le media");
//						fonctConst=0.0;
//					} else if (!fieldAbonne.get(pt1).equals(ab)) {
//						System.out.println("   Aie... le constructeur de Emprunt n'initialise pas convenablement l'abonne");
//						fonctConst=0.0;
//					} else {
//
//
//					}
//				} catch (Exception e) {
//					e.printStackTrace();
//					fonctConst=0.0;
//				}
//			}catch (Exception e) {
//				fonctConst=0.0;
//			}
//		}
//
//		Object pt1=null;
//		Object[] ar= {};
//		String resTitre="";
//		fonctGetDateEmprunt=1.0;
//
//
//		if (fieldEmprunt==null || mGetDateEmprunt==null) {
//			fonctGetDateEmprunt=0.0;
//		} else {
//			fonctGetDateEmprunt=1.0;
//			fieldEmprunt.setAccessible(true);
//			Date resuEmprunt;
//			try {
//				Class[] argl = {String.class};
//				Constructor cl =  cLivre.getDeclaredConstructor(argl);
//				Object[] arl = {"toto"};
//				Object livr = cl.newInstance(arl);
//				Abonne ab = new Abonne("titi", new Date(4,2,1903));
//				Date dateE=new Date(1,2,1903);
//				Date dateR=new Date(2,3,1903);
//				Object[] args = {dateE, dateR, livr, ab};
//				if (c2!=null) {
//					pt1 = (c2.newInstance(args));
//				} else {
//					pt1 = c0.newInstance(ar);
//				}
//				fieldEmprunt.set(pt1, dateE);
//				resuEmprunt = (Date)(mGetDateEmprunt.invoke(pt1, ar));
//				if (!resuEmprunt.equals(dateE)) {
//					System.out.println("   Aie... getDateEmprunt() ne retourne pas la valeur de la variable this."+fieldEmprunt.getName());
//					fonctGetDateEmprunt=0.0;
//				} else {
//					dateE=new Date(11,8,1905);
//					fieldEmprunt.set(pt1,dateE);
//					resuEmprunt = (Date)(mGetDateEmprunt.invoke(pt1,  ar));
//					if  (!resuEmprunt.equals(dateE)) {
//						System.out.println("   Aie... getDateEmprunt() ne retourne pas la valeur de la variable this."+fieldEmprunt.getName());
//						fonctGetDateEmprunt=0.0;
//					} else {
//						dateE=new Date(21,11,1907);
//						fieldEmprunt.set(pt1,dateE);
//						resuEmprunt = (Date)(mGetDateEmprunt.invoke(pt1,  ar));
//						if (!resuEmprunt.equals(dateE)) {
//							System.out.println("   Aie... getDateEmprunt() ne retourne pas la valeur de la variable this."+fieldEmprunt.getName());
//							fonctGetDateEmprunt=0.0;
//						}
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctGetDateEmprunt=0.0;
//			}
//		}
//
//		if (fieldRestitution==null || mGetDateRestitution==null) {
//			fonctGetDateRestitution=0.0;
//		} else {
//			fonctGetDateRestitution=1.0;
//			fieldRestitution.setAccessible(true);
//			Date resuRestitution;
//			try {
//				Class[] argl = {String.class};
//				Constructor cl =  cLivre.getDeclaredConstructor(argl);
//				Object[] arl = {"toto"};
//				Object livr = cl.newInstance(arl);
//				Abonne ab = new Abonne("titi", new Date(4,2,1903));
//				Date dateE=new Date(1,2,1903);
//				Date dateR=new Date(2,3,1903);
//				Object[] args = {dateE, dateR, livr, ab};
//				if (c2!=null) {
//					pt1 = (c2.newInstance(args));
//				} else {
//					pt1 = c0.newInstance(ar);
//				}
//				fieldRestitution.set(pt1, dateR);
//				resuRestitution = (Date)(mGetDateRestitution.invoke(pt1, ar));
//				if (!resuRestitution.equals(dateR)) {
//					System.out.println("   Aie... getDateRestitution() ne retourne pas la valeur de la variable this."+fieldRestitution.getName());
//					fonctGetDateEmprunt=0.0;
//				} else {
//					dateR=new Date(11,8,1905);
//					fieldRestitution.set(pt1,dateR);
//					resuRestitution = (Date)(mGetDateRestitution.invoke(pt1,  ar));
//					if  (!resuRestitution.equals(dateR)) {
//						System.out.println("   Aie... getDateRestitution() ne retourne pas la valeur de la variable this."+fieldRestitution.getName());
//						fonctGetDateEmprunt=0.0;
//					} else {
//						dateR=new Date(21,11,1907);
//						fieldRestitution.set(pt1,dateR);
//						resuRestitution = (Date)(mGetDateRestitution.invoke(pt1,  ar));
//						if (!resuRestitution.equals(dateR)) {
//							System.out.println("   Aie... getDateRestitution() ne retourne pas la valeur de la variable this."+fieldRestitution.getName());
//							fonctGetDateEmprunt=0.0;
//						}
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctGetDateEmprunt=0.0;
//			}
//		}
//
//
//		if (fieldMedia==null || mGetMedia==null) {
//			fonctGetMedia=0.0;
//		} else {
//			fonctGetMedia=1.0;
//			fieldMedia.setAccessible(true);
//			Object resuMedia;
//			try {
//				Class[] argl = {String.class};
//				Constructor cl =  cLivre.getDeclaredConstructor(argl);
//				Object[] arl = {"toto"};
//				Object livr = cl.newInstance(arl);
//				Abonne ab = new Abonne("titi", new Date(4,2,1903));
//				Date dateE=new Date(1,2,1903);
//				Date dateR=new Date(2,3,1903);
//				Object[] args = {dateE, dateR, livr, ab};
//				if (c2!=null) {
//					pt1 = (c2.newInstance(args));
//				} else {
//					pt1 = c0.newInstance(ar);
//				}
//				fieldMedia.set(pt1, livr);
//				resuMedia = (mGetMedia.invoke(pt1, ar));
//				if (!resuMedia.equals(livr)) {
//					System.out.println("   Aie... getMedia() ne retourne pas la valeur de la variable this."+fieldMedia.getName());
//					fonctGetMedia=0.0;
//				} else {
//					//dateR=new Date(11,8,1905);
//					arl[0]="tutu";
//					livr = cl.newInstance(arl);
//					fieldMedia.set(pt1,livr);
//					resuMedia = (mGetMedia.invoke(pt1,  ar));
//					if  (!resuMedia.equals(livr)) {
//						System.out.println("   Aie... getMedia() ne retourne pas la valeur de la variable this."+fieldMedia.getName());
//						fonctGetMedia=0.0;
//					} else {
//						//dateR=new Date(21,11,1907);
//						arl[0]="tata";
//						livr = cl.newInstance(arl);
//						fieldMedia.set(pt1,livr);
//						resuMedia = (mGetMedia.invoke(pt1,  ar));
//						if (!resuMedia.equals(livr)) {
//							System.out.println("   Aie... getMedia() ne retourne pas la valeur de la variable this."+fieldMedia.getName());
//							fonctGetMedia=0.0;
//						}
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctGetMedia=0.0;
//			}
//		}
//
//
//
//
//		if (fieldAbonne==null || mGetAbonne==null) {
//			fonctGetAbonne=0.0;
//		} else {
//			//System.out.println("test get abonne");
//			fonctGetAbonne=1.0;
//			fieldAbonne.setAccessible(true);
//			Abonne resuAbonne;
//			try {
//				Class[] argl = {String.class};
//				Constructor cl =  cLivre.getDeclaredConstructor(argl);
//				Object[] arl = {"toto"};
//				Object livr = cl.newInstance(arl);
//				Abonne ab = new Abonne("titi", new Date(4,2,1903));
//				Date dateE=new Date(1,2,1903);
//				Date dateR=new Date(2,3,1903);
//				Object[] args = {dateE, dateR, livr, ab};
//				if (c2!=null) {
//					pt1 = (c2.newInstance(args));
//				} else {
//					pt1 = c0.newInstance(ar);
//				}
//				fieldAbonne.set(pt1, ab);
//				resuAbonne = (Abonne)(mGetAbonne.invoke(pt1, ar));
//				if (!resuAbonne.equals(ab)) {
//					System.out.println("   Aie... getAbonne() ne retourne pas la valeur de la variable this."+fieldAbonne.getName());
//					fonctGetAbonne=0.0;
//				} else {
//					ab = new Abonne("tata", new Date(14,12,1913));
//					fieldAbonne.set(pt1,ab);
//					resuAbonne = (Abonne)(mGetAbonne.invoke(pt1,  ar));
//					if  (!resuAbonne.equals(ab)) {
//						System.out.println("   Aie... getAbonne() ne retourne pas la valeur de la variable this."+fieldAbonne.getName());
//						fonctGetAbonne=0.0;
//					} else {
//						ab = new Abonne("tutu", new Date(24,12,1923));
//						fieldAbonne.set(pt1,ab);
//						resuAbonne = (Abonne)(mGetAbonne.invoke(pt1,  ar));
//						if (!resuAbonne.equals(ab)) {
//							System.out.println("   Aie... getAbonne() ne retourne pas la valeur de la variable this."+fieldAbonne.getName());
//							fonctGetAbonne=0.0;
//						}
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctGetAbonne=0.0;
//			}
//		}
//
//		//System.out.println(emprunt+" - "+restitution+" - "+media+" - "+abonne+" - "+other);
//		//System.out.println(construct+" - "+fonctConst+" - "+fonctGetMedia+" - "+fonctGetDateEmprunt);
//		//System.out.println(fonctGetDateRestitution+" - "+fonctGetAbonne+" - "+getMedia+" - "+getAbonne);
//		//System.out.println(getDateEmprunt+" - "+getDateRestitution+" - "+autresMethodes);//+" - "+getAbonne);
//		return 
//				//(int)(estClasse*5)
//				(int)(emprunt*6)
//				+(int)(restitution*6)
//				+(int)(media*6)
//				+(int)(abonne*6)
//				+(int)(other*5)
//				+(int)(construct*11)
//				+(int)(fonctConst*11)
//				+(int)(fonctGetMedia*6)
//				+(int)(fonctGetDateEmprunt*6)
//				+(int)(fonctGetDateRestitution*6)
//				+(int)(fonctGetAbonne*6)
//				+(int)(getMedia*5)
//				+(int)(getAbonne*5)
//				+(int)(getDateEmprunt*5)
//				+(int)(getDateRestitution*5)
//				+(int)( (autresMethodes)*5);
//	}
//
//
//
//
//
//
//	@SuppressWarnings({ "rawtypes" })
//	public static int test24MediathequeMediatheque() {
//		double estClasse=0.0; // !!
//		//double extend=0.0;
//		//double emprunt=0.0;
//		//double restitution=0.0;
//		double medias=0.0;
//		double abonnes=0.0;
//		double other=0.0;
//		double getMedia=0.0;
//		double ajouter=0.0;
//		//double getAbonne=0.0;
//		//double getDateEmprunt=0.0;
//		//double getDateRestitution=0.0;
//		double autresMethodes=0.0;
//
//		double construct=0.0;
//		double fonctConst=0.0;
//		double fonctAjouter=0.0;
//		//double fonctGetDateEmprunt=0.0;
//		//double fonctGetDateRestitution=0.0;
//		double fonctNbMedias=0.0;
//
//		Class cLivre = Reflexion.getClass("s05.mediatheque.Livre");
//		Class cAbonne = Reflexion.getClass("s05.mediatheque.Abonne");
//		//if (cAbonne==null) {
//		//	System.out.println("   Aie... je ne trouve pas la classe Abonne dans le package mediatheque");
//		//return 0;
//		//}
//		Class cMediatheque= Reflexion.getClass("s05.mediatheque.Mediatheque");
//		if (cMediatheque==null) {
//			System.out.println("   Aie... je ne trouve pas la classe Mediatheque dans le package mediatheque");
//			return 0;
//		}
//		Class cIMedia = Reflexion.getClass("s05.mediatheque.IMedia");
//		/*if (cAbonne!=null && cIMedia.isInterface() && !cEmprunt.isInterface()&& Reflexion.extendsClass(cEmprunt, cAbonne)) {
//			extend=1.0;
//		} else {
//			System.out.println("   Aie... LivreAudio n'herite pas de Livre");
//		}*/
//		if (!cMediatheque.isInterface()) {
//			estClasse=1.0;
//		}
//
//		Field 	fieldMedias=null, fieldAbonnes = null, 
//				fieldOther=null;
//		Field[] tf = cMediatheque.getDeclaredFields();
//		int nbv=0;
//		for (Field f : tf) {
//			//System.out.println("type=="+f.getType().getName()+"<<<");
//			if (!Modifier.isStatic(f.getModifiers())) {
//				nbv++;
//			}
//			if ( cIMedia!=null && (f.getType().equals(List.class)|| f.getType().equals(Collection.class)||f.getType().equals(ArrayList.class)|| f.getType().equals(LinkedList.class)|| f.getType().equals(Set.class)||  f.getType().getName().startsWith("["))  && !Modifier.isStatic(f.getModifiers()) && f.getName().toLowerCase().contains("med")) {
//				if (fieldMedias==null) {
//					fieldMedias=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if ( cAbonne!=null && (f.getType().equals(List.class)|| f.getType().equals(Collection.class)||f.getType().equals(ArrayList.class)|| f.getType().equals(LinkedList.class)|| f.getType().equals(Set.class)||  f.getType().getName().startsWith("["))  && !Modifier.isStatic(f.getModifiers()) && !f.getName().toLowerCase().contains("med")) {
//				if (fieldAbonnes==null) {
//					fieldAbonnes=f;
//				} else {
//					fieldOther=f;
//				}
//			} else if (!Modifier.isStatic(f.getModifiers())) {
//				fieldOther=f;
//			}
//		}
//		if (fieldMedias==null) {
//			System.out.println("   Aie... Je ne trouve pas de variable d'instance permettant de memoriser l'ensemble des medias de la mediatheque");
//		} else {
//			medias=0.5;
//			if (Modifier.isPrivate(fieldMedias.getModifiers())) {
//				medias+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}
//		if (fieldAbonnes==null) {
//			System.out.println("   Aie... Je ne trouve pas de variable d'instance permettant de memoriser l'ensemble des abonnes de la mediatheque");
//		} else {
//			abonnes=0.5;
//			if (Modifier.isPrivate(fieldAbonnes.getModifiers())) {
//				abonnes+=0.5;
//			} else {
//				System.out.println("   Aie... les variables d'instance doivent etre private pour respecter le principe d'encapsulation");
//			}
//		}
//
//		if (fieldOther!=null) {
//			System.out.println("   Aie... Mediatheque dispose de la variable "+fieldOther.getName()+". Elle ne devrait avoir que les variables d'instances permettant de memoriser l'ensemble des media et l'ensemble des abonnes");
//			other=0.0;
//		} else {
//			if (abonnes!=0.0 ||  medias!=0.0) {
//				other=1.0;
//			}
//		}
//		if (fieldMedias!=null) fieldMedias.setAccessible(true);
//		if (fieldAbonnes!=null) fieldAbonnes.setAccessible(true);
//
//
//		Method mGetNombreDeMedias=null;
//		Method mAjouter=null;
//		Method mAutre=null;
//
//		for (Method m : cMediatheque.getDeclaredMethods()) {
//			System.out.println("declared : "+m.getName());
//			if (mGetNombreDeMedias==null && m.getName().toLowerCase().equals("getnombredemedias")) {
//				mGetNombreDeMedias=m;
//				getMedia=0.5;
//				if (m.getParameterTypes().length==0) {
//					getMedia+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getNombreDeMedias() ne doit pas avoir de parametres");
//				}
//				if (cIMedia!=null && m.getReturnType().equals(int.class)) {
//					getMedia+=0.25;
//				} else {
//					System.out.println("   Aie... la methode getNombreDeMedias() doit retourner un int");
//				}
//			} else if (mAjouter==null && m.getName().toLowerCase().equals("ajouter")) {
//				mAjouter=m;
//				ajouter=0.5;
//				if (m.getParameterTypes().length==1 && m.getParameterTypes()[0].equals(cIMedia)) {
//					ajouter+=0.25;
//				} else {
//					System.out.println("   Aie... la methode ajouter n'a pas le bon type de parametre");
//				}
//				if (cAbonne!=null && m.getReturnType().getName().equals("void")) {
//					ajouter+=0.25;
//				} else {
//					System.out.println("   Aie... la methode ajouter() n'a pas le bon type retour");
//				}
//			} 
//			else {
//				mAutre=m;
//				System.out.println("   Aie... le diagramme ne precise pas la methode "+m.getName()+" pour la classe Mediatheque");
//			}
//		}
//		if (mAutre==null && (mAjouter!=null || mGetNombreDeMedias!=null)) {
//			autresMethodes=1.0;
//		}
//		Class[] argConst = { };//Date.class, Date.class, cIMedia, cAbonne };
//		Constructor c2=null;
//		//Class[] argConst0 = { };
//		//Constructor c0=null;
//		try {
//			if (cIMedia!=null && cAbonne!=null) {
//				c2 = cMediatheque.getDeclaredConstructor(argConst);
//			}
//		} catch (NoSuchMethodException e) {
//			e.printStackTrace();
//			c2=null;
//		} catch (SecurityException e) {
//			e.printStackTrace();
//			c2=null;
//		}/*
//		if (c2==null) {
//			try {
//				c0 = cMediatheque.getDeclaredConstructor(argConst0);
//			} catch (NoSuchMethodException e) {
//				e.printStackTrace();
//				c0=null;
//			} catch (SecurityException e) {
//				e.printStackTrace();
//				c0=null;
//			}	
//		}*/
//		if (c2==null) {
//			System.out.println("   Aie... je ne trouve pas le constructeur Mediatheque(). Plusieurs fonctionnalites ne pourront pas etre verifiees sans la presence de ce constructeur");
//		} else {
//			construct=1.0;
//			//if (fieldEmprunt!=null) fieldEmprunt.setAccessible(true);
//			Object pt1=null;
//			//Class[] argl = {String.class};
//			//try {
//			//Constructor cl =  cLivre.getDeclaredConstructor(argl);
//			//Object[] arl = {"toto"};
//
//			/*Date resDateE=null;
//			Date resDateR=null;
//			Abonne resAbo = null;
//			Object resLivre=null;*/
//			fonctConst=1.0;
//			//System.out.println("test const");
//			try {
//				//Object livr = cl.newInstance(arl);
//				//Abonne ab = new Abonne("titi", new Date(4,2,1903));
//				//Date dateE=new Date(1,2,1903);
//				//Date dateR=new Date(2,3,1903);
//				Object[] args = {};//dateE, dateR, livr, ab};
//
//				pt1 = (c2.newInstance(args));
//				//if (fieldEmprunt!=null) resTitre=(String)fieldEmprunt.get(pt1);
//				//if (fieldRestitution!=null) resDuree=(int)fieldRestitution.get(pt1);
//				//resCote = (int)(mGetCote.invoke(pt1,  ar));
//				if (fieldMedias==null || fieldMedias.get(pt1)==null ) {// || (fieldMedias.getType().equals(List.class) && ((List<cIMedia>)fieldMedias).size())) {
//					//System.out.println("field="+fieldMedias);
//					//System.out.println("fieldget="+fieldMedias.get(pt1));
//					System.out.println("   Aie... le constructeur de Mediatheque n'initialise pas convenablement la collection de medias");
//					fonctConst=0.0; 
//
//				} else if (fieldAbonnes==null || fieldAbonnes.get(pt1)==null || (fieldAbonnes.get(pt1) instanceof List<?> && ((List<Abonne>) fieldAbonnes.get(pt1)).size()!=0)
//						|| (fieldAbonnes.get(pt1) instanceof ArrayList<?> && ((ArrayList<Abonne>) fieldAbonnes.get(pt1)).size()!=0)
//						|| (fieldAbonnes.get(pt1) instanceof LinkedList<?> && ((LinkedList<Abonne>) fieldAbonnes.get(pt1)).size()!=0)
//						) {
//					System.out.println("   Aie... le constructeur de Emprunt n'initialise pas convenablement l'abonne");
//					fonctConst=0.0;
//				} else {
//
//
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctConst=0.0;
//			}
//
//		}
//
//		Object pt1=null;
//		Object[] ar= {};
//		String resTitre="";
//	//	fonctGetDateEmprunt=1.0;
//
//
//		if (fieldMedias==null || mAjouter==null || c2==null) {
//			fonctAjouter=0.0;
//		} else {
//			fonctAjouter=1.0;
//			fieldMedias.setAccessible(true);
//			Object resuMedia;
//			try {
//				Class[] argl = {String.class};
//				if (cLivre==null) {
//				//	System.out.println("   Aie... je ne trouve pas la classe Livre : les tests ne peuvent pas verifier le bon fonctionnement de ajouter");
//					fonctAjouter=0.0;
//				} else {
//   				Constructor cl =  cLivre.getDeclaredConstructor(argl);
//					Object[] arl = {"toto"};
//					Object livr = cl.newInstance(arl);
//
//					Object[] args = {};//dateE, dateR, livr, ab};
//					Object[] ar2 = new Object[1];
//					if (c2!=null) {
//						pt1 = (c2.newInstance(args));
//					}
//					int type =0;
//					if ( cIMedia!=null && fieldMedias!=null && (fieldMedias.getType().equals(List.class)||  fieldMedias.getType().equals(Collection.class) || fieldMedias.getType().equals(ArrayList.class)  )) {
//						type=1;
//					} else if ( cIMedia!=null && fieldMedias!=null && (fieldMedias.getType().equals(LinkedList.class) )) {
//						type=2;
//					} else if ( cIMedia!=null && fieldMedias!=null && (fieldMedias.getType().getName().startsWith("[") )) {
//						type=3;
//					} else {
//					}
//					List ensemble =null;
//					if (type==1) {
//						ensemble=new ArrayList();
//					} else if (type==2) {
//						ensemble=new LinkedList();
//					}
//						
//					ar2[0]=livr;
//					fieldMedias.set(pt1, ensemble);
//					
//					 mAjouter.invoke(pt1, ar2);
//					 //resuMedia= fieldMedias.get(pt1);
//					 
//					if (!ensemble.contains(livr)) {
//						System.out.println("   Aie... ajouter n'ajoute pas le media.");
//						fonctAjouter=0.0;
//					} else {
//					}
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctAjouter=0.0;
//			}
//		}
//
//
//
//
//		if (fieldMedias==null || mGetNombreDeMedias==null) {
//			fonctNbMedias=0.0;
//		} else {
//			//System.out.println("test get abonne");
//			fonctNbMedias=1.0;
//			fieldMedias.setAccessible(true);
//			int  resuNbMedias;
//			try {
//				Class[] argl = {String.class};
//				if (cLivre==null) {
//				//	System.out.println("   Aie... je ne trouve pas la classe Livre : les tests ne peuvent pas verifier le bon fonctionnement de ajouter");
//					fonctNbMedias=0.0;
//				} else {
//   				Constructor cl =  cLivre.getDeclaredConstructor(argl);
//					Object[] arl = {"toto"};
//					Object livr = cl.newInstance(arl);
//
//					Object[] args = {};//dateE, dateR, livr, ab};
//					Object[] ar2 = new Object[1];
//					if (c2!=null) {
//						pt1 = (c2.newInstance(args));
//					}
//					int type =0;
//					if ( cIMedia!=null && fieldMedias!=null && (fieldMedias.getType().equals(List.class)||  fieldMedias.getType().equals(Collection.class) || fieldMedias.getType().equals(ArrayList.class)  )) {
//						type=1;
//					} else if ( cIMedia!=null && fieldMedias!=null && (fieldMedias.getType().equals(LinkedList.class) )) {
//						type=2;
//					} else if ( cIMedia!=null && fieldMedias!=null && (fieldMedias.getType().getName().startsWith("[") )) {
//						type=3;
//					} else {
//					}
//					List ensemble =null;
//					if (type==1) {
//						ensemble=new ArrayList();
//					} else if (type==2) {
//						ensemble=new LinkedList();
//					}
//						
//					ar2[0]=livr;
//					fieldMedias.set(pt1, ensemble);
//					
//					// mAjouter.invoke(pt1, ar2);
//					 //resuMedia= fieldMedias.get(pt1);
//					 resuNbMedias=(int)mGetNombreDeMedias.invoke(pt1, args);
//					 if (resuNbMedias!=ensemble.size()) {
//						 System.out.println("   Aie... apres m=new Mediatheque()   getNombreDeMedias() retourne "+resuNbMedias+" au lieu de "+ensemble.size());
//						 fonctNbMedias=0.0;
//					 } else {
//						ensemble.add(livr);
//						resuNbMedias=(int)mGetNombreDeMedias.invoke(pt1, args);
//						 if (resuNbMedias!=ensemble.size()) {
//							 System.out.println("   Aie... apres m=new Mediatheque()   getNombreDeMedias() retourne "+resuNbMedias+" au lieu de "+ensemble.size());
//							 fonctNbMedias=0.0;
//						 } else {
//							fonctNbMedias=1.0;
//						 }
//					 }
//					
//				}
//			} catch (Exception e) {
//				e.printStackTrace();
//				fonctAjouter=0.0;
//			}
//		}
//
//		//System.out.println(estClasse+" - "+medias+" - "+abonnes+" - "+other);
//		//System.out.println(getMedia+" - "+ajouter+" - "+autresMethodes+" - "+construct);
//		//System.out.println(fonctConst+" - "+fonctAjouter+" - "+fonctNbMedias+" - ");//+getAbonne);
//		
//		return  5 // existe
//				+(int)(estClasse*5)
//				+(int)(medias*10)
//				+(int)(abonnes*10)
//				+(int)(other*5)
//				+(int)(construct*10)
//				+(int)(fonctConst*10)
//				+(int)(fonctAjouter*10)
//				+(int)(ajouter*10)
//				+(int)(fonctNbMedias*10)
//				+(int)(getMedia*10)
//				+(int)( (autresMethodes)*5)  
//				;
//	}
}

